"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Reseller = void 0;
const RawView_1 = require("../lib/view/RawView");
const RawNonQuery_1 = require("../lib/model/RawNonQuery");
const Session_1 = require("../lib/model/Session");
const _406_1 = require("../lib/view/406");
// import { AppRoute } from "../lib/AppRoute";
const RawQuery_1 = require("../lib/model/RawQuery");
const markError_1 = require("./markError");
// var nodemailer = require("nodemailer");
const jwt = require('jsonwebtoken');
const Str = require('@supercharge/strings');
const bcrypt = __importStar(require("bcrypt"));
const setting_config_1 = require("../config/setting.config");
const FromSmtpMail = new setting_config_1.SMTPDetails();
const FromEmail = FromSmtpMail.from;
class Reseller {
    constructor() {
        // super();
    }
    saveReseller(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let sysInfo = (0, markError_1.ipAddressAndBrowser)(req);
            let sdata = req.body.data;
            let password = bcrypt.hashSync(sdata.password, 10);
            let organization = '';
            if (sdata.organization_name) {
                organization = sdata.organization_name.trim();
            }
            else {
                organization = '';
            }
            let obj = new RawQuery_1.ModelRawQuery(req, res);
            obj.qrysql = "SELECT rp.email ,r. username FROM `reseller` r JOIN `reseller_profile` rp ON rp.iduser=r.iduser WHERE username = '" + (0, markError_1.parseBody)(sdata.user_name) + "' OR email = '" + (0, markError_1.parseBody)(sdata.email) + "'";
            obj.prepare();
            obj.execute((_error, getUser) => {
                if (_error == 1) {
                    if (getUser.length > 0) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Username or Email Already Exists!",
                            status: 404
                        });
                        objv.execute();
                    }
                    else {
                        // To Insert Data in Theme
                        // type = 4 for reseller
                        let objb8 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        objb8.nonqrysql = "INSERT INTO  `theme`  SET `idaccount`='" + sessdata.idaccount + "', `brandName`='Signalmash', `domain`= 'https://portal.signalmash.com/',  `customLogo`='assets/img/logo.png', `email`='signalmash@portal.signalmash.com/', `phone`='1234567890', `support_url`='https://portal.signalmash.com/', `header_color`='blue', `navbar_color`='blue', `sidebar_color`='blue', `ssl_certificate`='test', `ssl_key`='test'";
                        objb8.prepare();
                        objb8.execute((__errTheme, inserTheme) => {
                            if (__errTheme == 1 && inserTheme.length > 0) {
                                console.log("Theme Data Inserted!");
                            }
                        });
                        // let isEmailV: any = !sdata.isEmailVerify || sdata.isEmailVerify == undefined || sdata.isEmailVerify == '' ? 'false' : 'true';
                        //let isMobileV: any = !sdata.isMobileVerify || sdata.isMobileVerify == undefined || sdata.isMobileVerify == '' ? 'false' : 'true';
                        // To Insert Data in Theme
                        // type = 4 for reseller
                        let objb7 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        // objb7.nonqrysql = "INSERT INTO `reseller` SET `idaccount`='" + sessdata.idaccount + "', `username`='" + parseBody(sdata.user_name) + "', `password`='" + password + "', `ext_name`='" + sdata.password + "', `idservice`='" + sdata.service[0].idservice + "', `type`='4', `status`= 'false',`isEmailVerify`='" + isEmailV + "',`isMobileVerify`='" + isMobileV + "',`ipAddress`='" + sysInfo.ipAddress[0] + "', `browser`='" + sysInfo.browserName + "',`isAddress`='" + sdata.isAddress + "',`isPlan`='" + sdata.isPlan + "'";
                        objb7.nonqrysql = "INSERT INTO `reseller` SET `idaccount`='" + sessdata.idaccount + "', `username`='" + (0, markError_1.parseBody)(sdata.user_name) + "', `password`='" + password + "', `ext_name`='" + (0, markError_1.parseBody)(sdata.password) + "', `idservice`='" + sdata.service[0].idservice + "', `type`='4', `status`= 'false',`isEmailVerify`='true',`isMobileVerify`='true',`ipAddress`='" + sysInfo.ipAddress[0] + "', `browser`='" + sysInfo.browserName + "',`isAddress`='" + sdata.isAddress + "',`isPlan`='" + sdata.isPlan + "',`organization_name`='" + (0, markError_1.parseBody)(organization) + "'";
                        objb7.prepare();
                        objb7.execute((__errUser, inserUser) => {
                            if (__errUser == 1 && inserUser.insertId > 0) {
                                let iduser = inserUser.insertId;
                                // To Insert Data in User Profile
                                let objb6 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                objb6.nonqrysql = "INSERT INTO `reseller_profile` SET `iduser`='" + iduser + "',`account_id`='" + sessdata.idaccount + "', `firstname`='" + (0, markError_1.parseBody)(sdata.first_name) + "', `lastname`='" + (0, markError_1.parseBody)(sdata.last_name) + "', `email`='" + (0, markError_1.parseBody)(sdata.email) + "', `phone`='" + sdata.contact_number + "',`profile_pic`='https://portal.signalmash.com/assets/img/icon.png'";
                                objb6.prepare();
                                objb6.execute((__errUP, inserUP) => {
                                    if (__errUP == 1 && inserUP.insertId > 0) {
                                        let idUP = inserUP.insertId;
                                        let obj15 = new Reseller();
                                        obj15.sendEmailVerify(req, res, sdata, iduser, next);
                                        // To Insert data in tariff_seller table
                                        //let QI: number = 0;
                                        //let iQry: any = "";
                                        // for (let x of sdata.tariff) {
                                        //     iQry += "INSERT INTO `tariff_seller` (`idaccount`, `iduser`, `idtariff`) VALUES(" + sessdata.idaccount + ", " + iduser + ", '" + x.idtariff + "');\n"
                                        //     QI++
                                        // }
                                        let qry0 = "INSERT INTO `tariff_seller`(`idaccount`, `iduser`, `idtariff`) VALUES ";
                                        for (let i = 0; i < sdata.tariff.length; i++) {
                                            let tariff = sdata.tariff[i].idtariff;
                                            qry0 += "(" + sessdata.idaccount + ", " + iduser + ", " + (0, markError_1.setToZero)(tariff) + "),";
                                        }
                                        let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj5.nonqrysql = qry0.slice(0, -1);
                                        obj5.prepare();
                                        obj5.execute((errTrf, resultTrf) => { });
                                        // if (QI > 0) {
                                        //     let obj5 = new ModelRawNonQuery(req, res);
                                        //     obj5.nonqrysql = iQry
                                        //     obj5.prepare();
                                        //     obj5.execute((errTrf, resultTrf) => { })
                                        // }
                                        let objm = new RawQuery_1.ModelRawQuery(req, res);
                                        objm.qrysql = "Select `plan_name`, `description` from `commission_plan` WHERE `id_plan`='" + sdata.plan_name[0].id_plan + "'";
                                        objm.prepare();
                                        objm.execute((err6, res6) => {
                                            let plan = res6[0].plan_name;
                                            let desc = res6[0].description;
                                            let objh = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                            objh.nonqrysql = "INSERT INTO  `commission_plan` SET `iduser`='" + iduser + "',`idaccount`='" + sessdata.idaccount + "', `plan_name`='" + (0, markError_1.parseBody)(plan) + "',`assigned_id`='" + sdata.plan_name[0].id_plan + "', `description`='" + (0, markError_1.parseBody)(desc) + "'";
                                            objh.prepare();
                                            objh.execute((err7, res7) => {
                                                let objv = new RawView_1.RawView(res);
                                                objv.prepare({ status: 200, message: "Reseller Created Successfully" });
                                                objv.execute();
                                                console.log("Reseller Data Inserted!");
                                            });
                                        });
                                    }
                                    else {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ status: 502, message: "Reseller Not Created Successfully!" });
                                        objv.execute();
                                    }
                                });
                            }
                        });
                    }
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                    objv.execute();
                }
            });
        });
    }
    updateResellerbyID(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            let sysInfo = (0, markError_1.ipAddressAndBrowser)(req);
            let sdata = req.body.data;
            let organization = '';
            if (sdata.organization_name) {
                organization = sdata.organization_name.trim();
            }
            else {
                organization = '';
            }
            let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
            obj.nonqrysql = "DELETE FROM `tariff_seller` WHERE iduser='" + sdata.iduser + "'";
            obj.prepare();
            obj.execute((_delError, delTariffSeller) => {
                if (_delError == 1) {
                    // let QI: number = 0;
                    // let iQry: any = "";
                    // for (let x of sdata.tariff) {
                    //     iQry += "INSERT INTO `tariff_seller` (`idaccount`, `iduser`, `idtariff`) VALUES(" + sessdata.idaccount + ", " + sdata.iduser + ", '" + x.idtariff + "');\n"
                    //     QI++
                    // }
                    // if (QI > 0) {
                    //     let obj5 = new ModelRawNonQuery(req, res);
                    //     obj5.nonqrysql = iQry
                    //     obj5.prepare();
                    //     obj5.execute((errTrf, resultTrf) => {
                    //     })
                    // }
                    let qry0 = "INSERT INTO `tariff_seller`(`idaccount`, `iduser`, `idtariff`) VALUES ";
                    for (let i = 0; i < sdata.tariff.length; i++) {
                        let tariff = sdata.tariff[i].idtariff;
                        qry0 += "(" + sessdata.idaccount + ", " + sdata.iduser + ", " + (0, markError_1.setToZero)(tariff) + "),";
                    }
                    let obj5 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj5.nonqrysql = qry0.slice(0, -1);
                    obj5.prepare();
                    obj5.execute((errTrf, resultTrf) => { });
                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj1.nonqrysql = "update reseller set `username`='" + (0, markError_1.parseBody)(sdata.user_name) + "',`ipAddress`='" + sysInfo.ipAddress[0] + "', `browser`='" + sysInfo.browserName + "',`isAddress`='" + sdata.isAddress + "',`isPlan`='" + sdata.isPlan + "',`idservice`='" + sdata.service[0].idservice + "',`organization_name`='" + (0, markError_1.parseBody)(organization) + "' where `iduser`='" + sdata.iduser + "'";
                    obj1.prepare();
                    obj1.execute((_userError, updateUser) => {
                        /* let isEmailV: any = !sdata.isEmailVerify || sdata.isEmailVerify == undefined || sdata.isEmailVerify == '' ? 'false' : 'true';
                        if (isEmailV !== 'true') {
                            let obj = new Reseller();
                            obj.sendEmailVerify(req, res, sdata, sdata.iduser, next);
                        } */
                        let obj2 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj2.nonqrysql = "update reseller_profile set `firstname`='" + (0, markError_1.parseBody)(sdata.first_name) + "',`lastname`='" + (0, markError_1.parseBody)(sdata.last_name) + "',`email`='" + sdata.email + "',`phone`='" + sdata.contact_number + "' where `iduser`='" + sdata.iduser + "'";
                        obj2.prepare();
                        obj2.execute((_upError, updateUp) => {
                            if (_upError == 1) {
                                let IdPlan = sdata.plan_name[0].id_plan;
                                let objm = new RawQuery_1.ModelRawQuery(req, res);
                                objm.qrysql = "Select `id_plan`,`plan_name`, `description` from `commission_plan` WHERE `id_plan`='" + IdPlan + "'";
                                objm.prepare();
                                objm.execute((err6, res1) => {
                                    let plan = res1[0].plan_name;
                                    let desc = res1[0].description;
                                    let IDplan = res1[0].id_plan;
                                    let obj9 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                    obj9.nonqrysql = "UPDATE `commission_plan` SET `assigned_id`='" + IdPlan + "',`plan_name`='" + (0, markError_1.parseBody)(plan) + "',`description`='" + (0, markError_1.parseBody)(desc) + "',updated_at=NOW() WHERE `iduser`='" + sdata.iduser + "'";
                                    obj9.prepare();
                                    obj9.execute((err6, resUp) => {
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare({ message: "Reseller Data Update Successfully", status: 200 });
                                        objv.execute();
                                    });
                                });
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Something Went Wrong!", status: 502 });
                                objv.execute();
                            }
                        });
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                    objv.execute();
                }
            });
        });
    }
    sendEmailVerify(req, res, sdata, iduser, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let secret = Str.random(15);
                let validationKey = jwt.sign({
                    exp: Math.floor(Date.now() / 1000) + (60 * 60),
                    data: sdata.email + sdata.password
                }, secret);
                let obj3 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj3.nonqrysql = "UPDATE `reseller` SET `validationKey`='" + validationKey + "', `secret`='" + secret + "', `email_verification_date`=NOW() WHERE `iduser`='" + iduser + "' AND  `is_deleted`=0";
                obj3.prepare();
                obj3.execute((_err, __result) => {
                    if (_err == 1) {
                        if (__result.affectedRows > 0) {
                            let obj5 = new RawQuery_1.ModelRawQuery(req, res);
                            obj5.qrysql = "SELECT `subject`, `template` FROM `email_template` WHERE `type`='reseller_welcome'";
                            obj5.prepare();
                            obj5.execute((emlErr, emlRes) => {
                                if (emlErr == 1) {
                                    if (emlRes.length > 0) {
                                        let tmpData = emlRes[0].template;
                                        tmpData = tmpData.replace(/{FIRST_NAME}/g, sdata.first_name);
                                        tmpData = tmpData.replace(/{LAST_NAME}/g, sdata.last_name);
                                        // var smtpTransport = nodemailer.createTransport({
                                        //     service: "gmail",
                                        //     host: "smtp.gmail.com",
                                        //     port: 587,
                                        //     secure: true,
                                        //     auth: {
                                        //         user: "mailto:donotreply@nglcommunications.com",
                                        //         pass: "yr%5V9GB"
                                        //     }
                                        // });
                                        // var mailOptions = {
                                        //     from: 'Signalmash <mailto:donotreply@signalmash.com>',
                                        //     to: sdata.email,
                                        //     usernmae: sdata.user_name,
                                        //     email: sdata.email,
                                        //     subject: `${emlRes[0].subject}`,
                                        //     text: "Thank You For Registration",
                                        //     html: `${tmpData}`
                                        // }
                                        // smtpTransport.sendMail(mailOptions, (_emailError: any, emailRes: any) => {
                                        //     if (_emailError) {
                                        //         console.log("Opps Email Not Sent!");
                                        //     } else {
                                        //         console.log("Email Send  Successfully!");
                                        //     }
                                        // });
                                        let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        obj1.nonqrysql = "INSERT INTO `email_send`(`iduser`, `idaccount`,`from`,`to`, `subject`,`text`,`html`,`type`,`status`) VALUES ('" + iduser + "','1','" + FromEmail + "','" + sdata.email + "', '" + (0, markError_1.parseBody)(emlRes[0].subject) + "','Mail Send for Reseller Account Created', '" + (0, markError_1.parseBody)(tmpData) + "','Mail Send for Reseller Account Created','10')";
                                        obj1.prepare();
                                        obj1.execute((_err, __result) => {
                                            if (_err == 1) {
                                                console.log("Email Send  Successfully!");
                                            }
                                            else {
                                                console.log("Oops Email Not Sent!");
                                            }
                                        });
                                    }
                                    else {
                                        console.log("Template Data Not Found!");
                                    }
                                }
                                else {
                                    console.log("Something Went Wrong with DB!");
                                }
                            });
                        }
                        else {
                            console.log("Invalid Key/Invalid Account!");
                        }
                    }
                    else {
                        console.log("Something Went Wrong with DB!");
                    }
                });
            }
            else {
                console.log(session);
            }
        });
    }
    getReseller(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                // obj.qrysql = "SELECT DISTINCT r.iduser,r.idaccount,r.idservice,r.idtariff,r.username,r.password,r.type,r.isEmailVerify,r.isMobileVerify,r.isAddress,r.isPlan,ext_name,rp.firstname,rp.lastname,rp.uploaded_file,rp.email,rp.phone,ts.tariff_seller_id,t.name,t.description,s.name,s.description,ba.address1,ba.address2,ba.city,ba.state,ba.postal_code,ba.country,ba.idbilling_address FROM `reseller` r INNER JOIN `reseller_profile` rp ON r.iduser=rp.iduser INNER JOIN `tariff_seller`  ts ON ts.iduser=rp.iduser INNER JOIN `tariff` t ON ts.idtariff=t.idtariff INNER JOIN `service` s ON r.idservice=s.idservice INNER JOIN `billing_address` ba ON r.idaccount=ba.idaccount WHERE r.is_deleted='0' AND r.type=4 GROUP BY r.username";
                /*NOTE HERE uploaded_file ---column are not added in table*/
                obj.qrysql = "SELECT DISTINCT r.iduser,r.idaccount,r.idservice,r.username,r.password,r.type,r.isEmailVerify,r.isMobileVerify,r.isAddress,r.isPlan,ext_name,rp.firstname,rp.lastname,rp.email,rp.phone,ts.tariff_seller_id,t.name,t.description,s.name,s.description,ba.address1,ba.address2,ba.city,ba.state,ba.postal_code,ba.country,ba.idbilling_address FROM `reseller` r LEFT JOIN `reseller_profile` rp ON r.iduser=rp.iduser LEFT JOIN `tariff_seller`  ts ON ts.iduser=rp.iduser LEFT JOIN `tariff` t ON ts.idtariff=t.idtariff LEFT JOIN `service` s ON r.idservice=s.idservice LEFT JOIN `billing_address` ba ON r.idaccount=ba.idaccount WHERE r.is_deleted='0' AND r.type=4 GROUP BY r.username";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ data: result, message: "Reseller Fetched Successfully!", status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    // getsingleReseller(req: Request, res: Response, next: NextFunction) {
    //     let data = req.query;
    //     let session = new SessionManagment(req, res, next);
    //     session.GetSession((error: any, sessdata: any) => {
    //         if (error == 1) {
    //             let obj = new ModelRawQuery(req, res);
    //             obj.qrysql = "SELECT * FROM `tariff_seller` WHERE `iduser`='" + data.type + "'";
    //             obj.prepare();
    //             obj.execute((_error: any, result1: any) => {
    //                 if (_error == 1) {
    //                     let obj1 = new ModelRawQuery(req, res);
    //                     obj1.qrysql = "SELECT * FROM `commission_plan` WHERE `iduser`='" + sessdata.iduser + "'";
    //                     obj1.prepare();
    //                     obj1.execute((_error2: any, result2: any) => {
    //                         if (_error2 == 1) {
    //                             let objv = new RawView(res);
    //                             objv.prepare({ data: result1, dataComPlan: result2, message: "Reseller Fetched Successfully!", status: 200 });
    //                             objv.execute();
    //                         }
    //                         else {
    //                             let objv = new RawView(res);
    //                             objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
    //                             objv.execute();
    //                         }
    //                     })
    //                 }
    //                 else {
    //                     let objv = new RawView(res);
    //                     objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
    //                     objv.execute();
    //                 }
    //             });
    //         }
    //         else {
    //             let objv = new Res406(res);
    //             objv.prepare("No session data there");
    //             objv.execute();
    //         }
    //     })
    // }
    getResellerPlan(req, res, next) {
        let data = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                // obj.qrysql = "SELECT * FROM `tariff_seller` WHERE `iduser`='" + data.type + "'";
                obj.qrysql = "SELECT `iduser`, `tariff_seller_id`, `idtariff` FROM `tariff_seller` WHERE `iduser`='" + data.type + "'";
                obj.prepare();
                obj.execute((_error, result1) => {
                    if (_error == 1) {
                        let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                        // obj1.qrysql = "SELECT * FROM `commission_plan` WHERE `iduser`='" + data.type + "'";
                        obj1.qrysql = "SELECT `iduser`, `id_plan`, `plan_name`, `assigned_id`, `is_default` FROM `commission_plan` WHERE `iduser`='" + data.type + "'";
                        obj1.prepare();
                        obj1.execute((_error2, result2) => {
                            if (_error2 == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result1, dataComPlan: result2, message: "Reseller Fetched Successfully!", status: 200 });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502 });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    /*DELETE query for RESELLER*/
    deleteReseller(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                // obj.nonqrysql = "DELETE FROM `tariff_seller` WHERE `iduser`='" + req.query.iduser + "'";
                obj.nonqrysql = "UPDATE reseller set `is_deleted`='1' WHERE `iduser`='" + req.query.iduser + "'";
                obj.prepare();
                obj.execute((_err, result) => {
                    if (_err == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Reseller Deleted Successfully!", status: 201, data: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Invalid Session Trying to Access!", status: 401 });
                objv.execute();
            }
        });
    }
    /***********************
    * Reseller List Filter  *
    ************************/
    resellerListFilter(req, res, next) {
        let data = req.query.type;
        let sdata = JSON.parse(data);
        let condition = "";
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                if (sdata.fromDate && sdata.toDate) {
                    condition += 'r.`created` BETWEEN "' + sdata.fromDate + ' 00:00:00" AND "' + sdata.toDate + ' 23:59:59" AND ';
                }
                if (sdata.email)
                    condition += 'rp.`email` LIKE "%' + (0, markError_1.parseBody)(sdata.email) + '%" AND ';
                if (sdata.selectedUser) {
                    condition += 'r.`iduser`="' + sdata.selectedUser[0].iduser + '" AND ';
                }
                if (sdata.username)
                    condition += 'r.`username` LIKE "%' + (0, markError_1.parseBody)(sdata.username) + '%" AND ';
                if (sdata.created)
                    condition += 'r.`created` LIKE "%' + sdata.created + '%" AND ';
                obj.qrysql = "SELECT DISTINCT r.iduser,r.idaccount,r.organization_name,r.idservice,r.password,r.username,r.type,r.isEmailVerify,r.isMobileVerify,r.isAddress,r.isPlan,ext_name,rp.firstname, rp.lastname,rp.email,rp.phone,DATE_FORMAT(r.`created`, '%Y-%m-%d %H:%i:%s')`created`,COALESCE(uf.filepath,'N/A')`filepath`,ts.tariff_seller_id,t.name,t.description,s.name,s.description FROM `reseller` r LEFT JOIN `user_file` uf ON r.iduser = uf.iduser LEFT JOIN `reseller_profile` rp ON r.iduser = rp.iduser LEFT JOIN `tariff_seller` ts ON ts.iduser=rp.iduser LEFT JOIN `tariff` t ON ts.idtariff=t.idtariff LEFT JOIN `service` s ON r.idservice=s.idservice WHERE " + condition + "  r.`is_deleted`='0' AND r.`type`=4 GROUP BY r.username";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            data: result,
                            message: "Reseller List Fetched Successfully!",
                            status: 200
                        });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Reseller!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /**-------For commission detail -----------**/
    /*GET query for Commission details */
    /* commissionDetails(req: Request, res: Response, next: NextFunction) {
        let sdata = req.query;
        let session = new SessionManagment(req, res, next);
        session.GetSession((err: any, sessdata) => {
            if (err == 1) {
                let obj = new ModelRawQuery(req, res);

                obj.qrysql = "SELECT r.username,r.iduser,cd.date,COALESCE(cd.reseller_name,'N/A') reseller_name,COALESCE(cd.total_invoice_amount,'N/A')total_invoice_amount,COALESCE(cd.commissinable_revenue,'N/A') commissinable_revenue ,COALESCE(cd.non_commissinable_revenue,'N/A') non_commissinable_revenue,COALESCE(cd.commission_amount,'N/A')commission_amount,COALESCE(cd.transaction_id,'N/A')transaction_id, COALESCE(cd.status,'N/A')`status` FROM `reseller` r LEFT JOIN `commission_details` cd ON cd.iduser=r.iduser WHERE r.`type`='4' AND `is_deleted`='0'";
                obj.prepare();
                obj.execute((_error: any, result: any) => {
                    if (result) {
                        let objv = new RawView(res);
                        objv.prepare({ message: "Fetched Data Successfully!", data: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView(res);
                        objv.prepare({ message: "Something Went Wrong!" });
                        objv.execute();
                    }
                });
            }
        });
    } */
    /***********************
    * Commission Details Filter  *
    ************************/
    commDetailsFilter(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let data = req.query.type;
                let sdata = JSON.parse(data);
                let condition = "";
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                if (sdata.fromDate && sdata.toDate) {
                    condition += '`date` BETWEEN "' + sdata.fromDate + ' 00:00:00" AND "' + sdata.toDate + ' 23:59:59" AND ';
                }
                if (sdata.selectedUser) {
                    condition += '`iduser`="' + sdata.selectedUser + '" AND ';
                }
                if (sdata.transaction_id)
                    condition += '`transaction_id` LIKE "%' + (0, markError_1.parseBody)(sdata.transaction_id) + '%" AND ';
                if (sdata.status) {
                    condition += '`status` = "' + sdata.status + '" AND ';
                }
                obj.qrysql = "SELECT username, reseller_name,cs_id,`iduser`, `date` ,COALESCE(DATE_FORMAT(`date`, '%Y-%m-%d %H:%i:%s'),'N/A') AS `formatted_date`,COALESCE(reseller_name, 'N/A') AS reseller_name, COALESCE(total_invoice_amount, 'N/A') AS total_invoice_amount,COALESCE(commissinable_revenue, 'N/A') AS commissinable_revenue,COALESCE(non_commissinable_revenue, 'N/A') AS non_commissinable_revenue,COALESCE(commission_amount, 'N/A') AS commission_amount,COALESCE(transaction_id, 'N/A') AS transaction_id, COALESCE(status, 'N/A') AS `status`,`comment` FROM `commission_summary` WHERE " + condition + " `type` = '4' ORDER BY `date` DESC";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                data: result,
                                message: "Commission Details Fetched Successfully!",
                                status: 200
                            });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                message: "No Record Found!",
                                status: 401,
                                error: result
                            });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({
                            message: "Something Went Wrong With Fetched Commission Details!",
                            status: 502,
                            error: result
                        });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    updateTransAmount(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                if (sessdata.type == 1) {
                    var sdata = JSON.parse(req.body.data);
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj.nonqrysql = "UPDATE `commission_summary` SET `comment`='" + (0, markError_1.parseBody)(sdata.value.comment) + "', `transaction_id`='" + (0, markError_1.parseBody)(sdata.value.transitionId) + "',`status`='Paid' WHERE `cs_id`='" + sdata.cs_id + "'";
                    obj.prepare();
                    obj.execute((_error, result) => {
                        if (_error == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Payment Disburse Successfully!", data: result, status: 200 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something Went Wrong!", status: 502, error: result });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Service Unavailable!", status: 503 });
                    objv.execute();
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /**---------- CRUD For commission plan ----------**/
    /*Inset query for Commission Plan */
    saveCommissionPlan(req, res, next) {
        var rdata;
        rdata = req.body.data;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                let obj1 = new RawQuery_1.ModelRawQuery(req, res);
                // obj1.qrysql = "SELECT * FROM `commission_plan` where `plan_name` = '" + parseBody(rdata.plan_name) + "' AND `iduser`='" + sessdata.iduser + "'";
                obj1.qrysql = "SELECT `iduser`, `plan_name` FROM `commission_plan` where `plan_name` = '" + (0, markError_1.parseBody)(rdata.plan_name) + "' AND `iduser`='" + sessdata.iduser + "'";
                obj1.prepare();
                obj1.execute((_error, plan) => {
                    if (_error == 1) {
                        if (plan.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                message: "Plan Name Already Exists In Your Commission Plan List!",
                                status: 404
                            });
                            objv.execute();
                        }
                        else {
                            let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                            obj1.nonqrysql = "INSERT INTO `commission_plan` (`idaccount`,`iduser`,`plan_name`, `description`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + (0, markError_1.parseBody)(rdata.plan_name) + "', '" + (0, markError_1.parseBody)(rdata.description) + "')";
                            obj1.prepare();
                            obj1.execute((_error, allcamp) => {
                                if (_error == 1) {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ status: 200, message: "Commission Plan Saved Successfully!" });
                                    objv.execute();
                                }
                                else {
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({ status: 502, message: "Commission Plan Not Created Successfully!" });
                                    objv.execute();
                                }
                            });
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Connection!", status: 502, error: plan });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    // saveCommissionPlan(req: Request, res: Response, next: NextFunction) {
    //     let session = new SessionManagment(req, res, next);
    //     session.GetSession((error: any, sessdata: any) => {
    //         if (error == 1) {
    //             var rdata: any;
    //             rdata = req.body.data;
    //             let obj1 = new ModelRawQuery(req, res);
    //             obj1.qrysql = "INSERT INTO `commission_plan` (`idaccount`,`iduser`,`plan_name`, `description`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + rdata.plan_name + "', '" + rdata.description + "')";
    //             obj1.prepare();
    //             obj1.execute((_error: any, allcamp: any) => {
    //                 if (_error == 1) {
    //                     let objv = new RawView(res);
    //                     objv.prepare({ status: 200, message: "Commission Plan Saved Successfully!" });
    //                     objv.execute();
    //                 }
    //                 else {
    //                     let objv = new RawView(res);
    //                     objv.prepare({ status: 502, message: "Commission Plan Not Created Successfully!" });
    //                     objv.execute();
    //                 }
    //             });
    //         }
    //         else {
    //             let objv = new Res406(res);
    //             objv.prepare("No session data there");
    //             objv.execute();
    //         }
    //     });
    // }
    /*GET query for Commission Plan */
    getCommissionPlan(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var sdata = req.query;
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT `idaccount`,`iduser`,`is_default`,`id_plan`,`plan_name`,`description`,`created_at`,`updated_at`,`assigned_id` FROM `commission_plan` WHERE `iduser`='" + sessdata.iduser + "' AND `idaccount`='" + sessdata.idaccount + "' ORDER BY `created_at` DESC";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Commission Plan Fetched Successfully!", data: result, status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Get Commission Plan List!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /*PUT query for Commission Plan */
    updateCommissionPlan(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var sdata = req.body.data;
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "UPDATE `commission_plan` SET `plan_name`='" + (0, markError_1.parseBody)(sdata.plan_name) + "', `description`='" + (0, markError_1.parseBody)(sdata.description) + "', `updated_at`=NOW() WHERE `id_plan`='" + sdata.id_plan + "'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Commission Plan Updated Successfully!", data: result, status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Commission Plan!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /*DELETE query for Commission Plan*/
    deleteCommissionPlan(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "DELETE FROM `commission_plan` WHERE `id_plan`='" + req.query.id_plan + "'";
                obj.prepare();
                obj.execute((_err, result) => {
                    if (_err == 1) {
                        let obj2 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj2.nonqrysql = "DELETE FROM `commission_tier` WHERE `id_plan`='" + req.query.id_plan + "'";
                        obj2.prepare();
                        obj2.execute((_errs, result) => {
                            if (_errs == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Commission Plan Deleted Successfully!", status: 201, data: result });
                                objv.execute();
                            }
                        });
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Commission Plan!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Invalid Session Trying to Access!", status: 401 });
                objv.execute();
            }
        });
    }
    // singleGetCommissionPlan(req: Request, res: Response, next: NextFunction) {
    //     let sdata = req.query;
    //     let session = new SessionManagment(req, res, next);
    //     session.GetSession((err: any, sessdata) => {
    //         if (err == 1) {
    //             let obj = new ModelRawQuery(req, res);
    //             obj.qrysql = "SELECT * FROM `commission_plan` WHERE `id_plan`='" + sdata.id_plan + "'";
    //             obj.prepare();
    //             obj.execute((_error: any, result: any) => {
    //                 if (result) {
    //                     let objv = new RawView(res);
    //                     objv.prepare({ message: "Fetched Data Successfully!", data: result[0] });
    //                     objv.execute();
    //                 }
    //                 else {
    //                     let objv = new RawView(res);
    //                     objv.prepare({ message: "Something Went Wrong!" });
    //                     objv.execute();
    //                 }
    //             });
    //         }
    //     });
    // }
    /*******************
    * Commission Plan Filter  *
    *******************/
    // public commissionFilter(req: Request, res: Response, next: NextFunction) {
    //     let sdata: any = req.query.type;
    //     let data = JSON.parse(sdata);              
    //     let condition: any = "";
    //     let session = new SessionManagment(req, res, next);
    //     session.GetSession((error: any, sessdata: any) => {
    //         if (error == 1) {
    //             let obj = new ModelRawQuery(req, res);
    //             if (data.fromDate && data.toDate) {
    //                 condition += 'AND `created_at` BETWEEN "' + data.fromDate + ' 00:00:00" AND "' + data.toDate + ' 23:59:59"';
    //             }
    //             if (data.plan_name) {
    //                 condition += 'AND `plan_name` LIKE "%' + parseBody(data.plan_name) + '%"';
    //             }
    //             obj.qrysql = "SELECT `idaccount`,`iduser`,`is_default`,`id_plan`,`plan_name`,`description`,DATE_FORMAT(`created_at`, '%Y-%m-%d %H:%i:%s')`created_at` FROM `commission_plan` WHERE  `iduser`='" + sessdata.iduser + "' " + condition + "";
    //             obj.prepare();
    //             obj.execute((_error: any, result: any) => {                    
    //                 if (_error == 1) {
    //                     let objv = new RawView(res);
    //                     objv.prepare({
    //                         data: result,
    //                         message: "Commission Plan List Fetched Successfully!",
    //                         status: 200
    //                     });
    //                     objv.execute();
    //                 }
    //                 else {
    //                     let objv = new RawView(res);
    //                     objv.prepare({
    //                         message: "Something Went Wrong With Fetched Commission Plan!",
    //                         status: 502,
    //                         error: result
    //                     });
    //                     objv.execute();
    //                 }
    //             });
    //         }
    //         else {
    //             let objv = new Res406(res);
    //             objv.prepare(session);
    //             objv.execute();
    //         }
    //     });
    // }
    /**--------------- CRUD Update function For commission Tier ----------**/
    /*Inset query for Commission Tier */
    /* saveCommissionTier(req: Request, res: Response, next: NextFunction) {
         let session = new SessionManagment(req, res, next);
         session.GetSession((error: any, sessdata: any) => {
             if (error == 1) {
                 var rdata: any;
                 rdata = JSON.parse(req.body.data);
                 let sdata: any = rdata.tierData;
                 let tier:number=Math.floor(Object.keys(sdata).length/4)
                 let toamount:any = []
                 let from_amount:any = []
                 let commission:any = []
                 let tiers:any = []
                 for(let i= 0; i<tier; i++){
                   
                     from_amount.push(sdata['from_amount'+(i+1)])
                    
                     toamount.push(sdata['to_amount'+(i+1)])
                     
                     commission.push(sdata['commission'+(i+1)])
                     
                     tiers.push(sdata['tier'+(i+1)])
                     let obj1 = new ModelRawNonQuery(req, res);
                     obj1.nonqrysql = "INSERT INTO `commission_tier` (`idaccount`,`iduser`,`id_plan`,`tier`, `from_amount`,`to_amount`,`commission`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + rdata.idPlan + "','" + tiers[i] + "', '" + from_amount[i] + "','" + toamount[i] + "','" + commission[i] + "')";
                     // obj1.qrysql = "";
                     obj1.prepare();
                     obj1.execute((_error: any, allcamp: any) => {
                         if (_error == 1) {
                             if(i==tier-1){
                             let objv = new RawView(res);
                             objv.prepare({ status: 200, message: "Commission Tier Saved Successfully!" });
                             objv.execute();
                             }
                         }
                         else {
                             let objv = new RawView(res);
                             objv.prepare({ status: 502, message: "Commission Tier Not Created Successfully!" });
                             objv.execute();
                         }
                         });
                 }
             }
             else {
                 let objv = new Res406(res);
                 objv.prepare("No session data there");
                 objv.execute();
             }
         });
     }*/
    // New
    saveCommissionTier(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var rdata;
                rdata = JSON.parse(req.body.data);
                let sdata = rdata.tierData;
                let tier = Math.floor(Object.keys(sdata).length);
                for (let i = 0; i < tier; i++) {
                    let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    obj1.nonqrysql = "INSERT INTO `commission_tier` (`idaccount`,`iduser`,`id_plan`,`tier`, `from_amount`,`to_amount`,`commission`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + rdata.idPlan + "','" + sdata[i].tier + "', '" + sdata[i].from_amount + "','" + sdata[i].to_amount + "','" + sdata[i].commission + "')";
                    // obj1.qrysql = "";
                    obj1.prepare();
                    obj1.execute((_error, allcamp) => {
                        if (_error == 1) {
                            if (i == tier - 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ status: 200, message: "Commission Tier Saved Successfully!" });
                                objv.execute();
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 502, message: "Commission Tier Not Created Successfully!" });
                            objv.execute();
                        }
                    });
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare("No session data there");
                objv.execute();
            }
        });
    }
    /*GET query for Commission Tier */
    getCommissionTier(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var sdata = req.body;
                let id_plan = req.query.type;
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                obj.qrysql = "SELECT `id_tier`,`id_plan`,`tier`,`from_amount`,`to_amount`,`commission` FROM `commission_tier` WHERE `id_plan`='" + id_plan + "' AND `iduser`='" + sessdata.iduser + "' ";
                obj.order = "tier";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Commission Tier Fetched Successfully!", data: result, status: 200 });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Get Commission Tier List!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /*PUT query for Commission Tier */
    /* updateCommissionTier(req: Request, res: Response, next: NextFunction) {
         let session = new SessionManagment(req, res, next);
         session.GetSession((error: any, sessdata: any) => {
             if (error == 1) {
                 var rdata: any;
                 let sdata = JSON.parse(req.body.data);
                 console.log("updatesdataa",sdata);
                 
                    sdata.forEach((element:any,index:any)=>{
                         let obj = new ModelRawNonQuery(req, res);
                         let sql = ""
                         if(element.id_tier=='undefined' || element.id_tier==undefined){
                             sql="INSERT INTO `commission_tier` (`idaccount`,`iduser`,`id_plan`,`tier`, `from_amount`,`to_amount`,`commission`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + element.id_plan + "','" + element.tier + "', '" + element.from_amount+ "','" +element.to_amount + "','" +  element.commission  + "')";
                         }
                         else{
                             console.log("update data");
 
                             sql="UPDATE `commission_tier` SET `iduser`='" + sessdata.iduser + "',`idaccount`='" + sessdata.idaccount + "',`tier`='" + element.tier + "', `from_amount`='" + element.from_amount + "', `to_amount`='" + element.to_amount + "',`commission`='" + element.commission + "' WHERE `id_tier` =" + element.id_tier + "";
                         }
                         
                         obj.nonqrysql =sql
                         obj.prepare();
                         obj.execute((_error: any, result: any) => {
                             if (_error == 1) {
                                 if(sdata.length==index+1){
                                     let objv = new RawView(res);
                                     objv.prepare({ message: "Commission Tier Updated Successfully!", data: result, status: 200 });
                                     objv.execute();
                                 }
                                 
                             } else {
                                 let objv = new RawView(res);
                                 objv.prepare({ message: "Something Went Wrong With Commission Tier!", status: 502, error: result });
                                 objv.execute();
                             }
                         });
                     
                     })
 
             }
             else {
                 let objv = new Res406(res);
                 objv.prepare(session);
                 objv.execute();
             }
         });
     }*/
    // NEW
    updateCommissionTier(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                var rdata;
                let sdata = JSON.parse(req.body.data);
                rdata = sdata.tierData;
                let tier = Math.floor(Object.keys(rdata).length);
                for (let i = 0; i < tier; i++) {
                    let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                    let sql = "";
                    if (rdata[i].id_tier == 'undefined' || rdata[i].id_tier == undefined) {
                        sql = "INSERT INTO `commission_tier` (`idaccount`,`iduser`,`id_plan`,`tier`, `from_amount`,`to_amount`,`commission`) VALUES('" + sessdata.idaccount + "','" + sessdata.iduser + "','" + rdata[i].id_plan + "','" + rdata[i].tier + "', '" + rdata[i].from_amount + "','" + rdata[i].to_amount + "','" + rdata[i].commission + "')";
                    }
                    else {
                        sql = "UPDATE `commission_tier` SET `iduser`='" + sessdata.iduser + "',`idaccount`='" + sessdata.idaccount + "',`tier`='" + rdata[i].tier + "', `from_amount`='" + rdata[i].from_amount + "', `to_amount`='" + rdata[i].to_amount + "',`commission`='" + rdata[i].commission + "' WHERE `id_tier` =" + rdata[i].id_tier + "";
                    }
                    obj.nonqrysql = sql;
                    obj.prepare();
                    obj.execute((_error, result) => {
                        if (_error == 1) {
                            if (i == tier - 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "Commission Tier Updated Successfully!", data: result, status: 200 });
                                objv.execute();
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Something Went Wrong With Commission Tier!", status: 502, error: result });
                            objv.execute();
                        }
                    });
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    /*DELETE query for Commission Tier*/
    deleteCommissionTier(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj.nonqrysql = "DELETE FROM `commission_tier` WHERE `id_tier`='" + req.query.id_tier + "'";
                obj.prepare();
                obj.execute((_err, result) => {
                    if (_err == 1) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Commission Tier Deleted Successfully!", status: 201, data: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong With Commission Tier!", status: 502, error: result });
                        objv.execute();
                    }
                });
            }
            else {
                let objv = new RawView_1.RawView(res);
                objv.prepare({ message: "Invalid Session Trying to Access!", status: 401 });
                objv.execute();
            }
        });
    }
    commissionTerm(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                //obj.qrysql = "SELECT invoice_monthly_key,status FROM `commission_terms` WHERE `iduser`='" + sessdata.iduser + "' AND `idaccount`='" + sessdata.idaccount + "'";
                obj.qrysql = "SELECT invoice_monthly_key,status FROM `commission_terms`";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (result) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Fetched Data Successfully!", data: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong!" });
                        objv.execute();
                    }
                });
            }
        });
    }
    /*Customer Details query*/
    getResCustomer(req, res, next) {
        let sdata = req.query;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                //obj.qrysql = "SELECT `username` FROM `user` WHERE `reseller_iduser`='" + sdata.type + "' AND `type`='2', AND `is_deleted`='0'";
                obj.qrysql = "SELECT u.username, ac.san,COALESCE(im.total_amount,'N/A')total_amount,COALESCE(im.`created_at`, 'N/A')`created_at` FROM `user`u INNER JOIN `account`ac ON u.idaccount=ac.idaccount LEFT JOIN `invoice` inv ON u.idaccount=inv.idaccount LEFT JOIN `invoice_monthly`im ON inv.idinvoice=im.idinvoice WHERE reseller_iduser='" + sdata.type + "' AND `type`='2' AND is_deleted='0'";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (result) {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Fetched Data Successfully!", data: result });
                        objv.execute();
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong!" });
                        objv.execute();
                    }
                });
            }
        });
    }
    ResellerLogin(req, res, next) {
        let sdata = req.body.data;
        let pass1 = sdata.password;
        let obj = new RawQuery_1.ModelRawQuery(req, res);
        obj.qrysql = "SELECT iduser, idaccount, username, password, type, `default`, idservice AS idtariff, isEmailVerify, isMobileVerify, isPlan, isAddress, newUser_status, '-08:00' AS client_time, IF(is_deleted = 0, 9, is_deleted) AS acc_status, resetPassword FROM reseller WHERE username='" + (0, markError_1.parseBody)(sdata.username) + "';";
        if (obj.prepare()) {
            obj.execute((error, result) => {
                if (result.length > 0) {
                    let objup = new RawQuery_1.ModelRawQuery(req, res);
                    objup.qrysql = "SELECT email FROM `reseller_profile` WHERE `iduser`='" + result[0].iduser + "'";
                    objup.prepare();
                    objup.execute((__errorE, emailE) => {
                        if ((bcrypt.compareSync(pass1, result[0].password) || (pass1 == result[0].password))) {
                            if (result[0].type == 4) {
                                let data = result[0];
                                let tmp = "{\"sessionType\": \"" + sdata.sessionType + "\"}";
                                let loginType = JSON.parse(tmp);
                                let Result = Object.assign(data, loginType);
                                if ((data.acc_status == 9) || (sdata.typeCheck && sdata.typeCheck == "admin_checking")) {
                                    delete data.acc_status;
                                    let session = new Session_1.SessionManagment(req, res, next);
                                    session.SetSession(Result, (error, sessdata) => {
                                        // To set User Login Activity
                                        let sysInfo = (0, markError_1.ipAddressAndBrowser)(req);
                                        let objh = new RawNonQuery_1.ModelRawNonQuery(req, res);
                                        objh.nonqrysql = "INSERT INTO `user_login_history`(`iduser`, `idaccount`, `type`, `token`, `ipaddress`, `browser`, `login_time`, `login_type`) VALUES ('" + result[0].iduser + "','" + result[0].idaccount + "','" + result[0].type + "', '" + Result.authkey + "', '" + sysInfo.ipAddress[0] + "', '" + sysInfo.browserName + "', NOW(),'login')";
                                        objh.prepare();
                                        objh.execute((error, data) => {
                                        });
                                        // To Merge
                                        let tmp = "{\"email\": \"" + emailE[0].email + "\"}";
                                        let emType = JSON.parse(tmp);
                                        let data1 = Object.assign(data, emType);
                                        let objv = new RawView_1.RawView(res);
                                        objv.prepare(data1);
                                        objv.execute();
                                    });
                                }
                                else {
                                    let errMsg = data.acc_status == 1 ? "Your account deletion in under process!" : "Your account has been deleted, If you want to restore kindly contact with customer support!";
                                    let errCode = data.acc_status == 1 ? "DelInProcess" : "Deleted";
                                    let objv = new RawView_1.RawView(res);
                                    objv.prepare({
                                        message: errMsg, error: errCode
                                    });
                                    objv.execute();
                                }
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ message: "You are not Authorized for this Panel!" });
                                objv.execute();
                            }
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                message: "Invalid Username/Password, Kindly check again!"
                            });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ message: "Invalid Username/Password, Kindly check again!" });
                    objv.execute();
                }
            });
        }
        else {
            let objv = new RawView_1.RawView(res);
            objv.prepare({
                message: "Few parameter are missing in request!"
            });
            objv.execute();
        }
    }
    setDefaultplan(req, res, next) {
        let sdata = req.body;
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((sessErr, sessData) => {
            if (sessErr == 1) {
                let obj1 = new RawNonQuery_1.ModelRawNonQuery(req, res);
                obj1.nonqrysql = "UPDATE `commission_plan` SET `is_default`='false' WHERE `iduser`='" + sdata.data.split('-')[1] + "'";
                obj1.prepare();
                obj1.execute((_error, result) => {
                    if (_error == 1) {
                        let obj = new RawNonQuery_1.ModelRawNonQuery(req, res);
                        obj.nonqrysql = "UPDATE `commission_plan` SET `is_default`='true' WHERE `iduser`='" + sdata.data.split('-')[1] + "' AND `id_plan`='" + sdata.data.split('-')[0] + "'";
                        obj.prepare();
                        obj.execute((_error, result) => {
                            if (_error == 1) {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, message: "Default Commission Changed Successfully!", status: 201 });
                                objv.execute();
                            }
                            else {
                                let objv = new RawView_1.RawView(res);
                                objv.prepare({ data: result, message: "Something Went Wrong With Commission Plan", status: 502 });
                                objv.execute();
                            }
                        });
                    }
                });
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    customerDFilter(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((err, sessdata) => {
            if (err == 1) {
                let data = req.query.type;
                let sdata = JSON.parse(data);
                let obj = new RawQuery_1.ModelRawQuery(req, res);
                let condition = '';
                if (sdata.selectedUser) {
                    condition += ' AND `reseller_iduser`="' + sdata.selectedUser + '" ';
                }
                if (sdata.fromDate) {
                    condition += " AND DATE_FORMAT(`created_at`,'%Y-%m-%d')>='" + sdata.fromDate + "'";
                }
                if (sdata.toDate) {
                    condition += " AND DATE_FORMAT(`created_at`,'%Y-%m-%d')<='" + sdata.toDate + "'";
                }
                if (sdata.san) {
                    condition += ' AND `cust_idaccount` LIKE "%' + Math.floor(sdata.san - 100000000) + '%" ';
                }
                if (sdata.commission_amount)
                    condition += 'AND `commission_amount` LIKE "%' + sdata.commission_amount + '%" ';
                obj.qrysql = "SELECT (100000000 + `cust_idaccount`) `san`, `reseller_iduser`, `invoice_number`,`reseller_name`, `customer_name`, `commission_amount`, `total_amount`,COALESCE(DATE_FORMAT(`created_at`, '%Y-%m-%d %H:%i:%s'),'N/A') `created_at` FROM `commission_detail` WHERE `cd_id` !='' " + condition + "";
                obj.prepare();
                obj.execute((_error, result) => {
                    if (_error == 1) {
                        if (result.length > 0) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "Fetched Data Successfully!", data: result, status: 200 });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ message: "No Record Found!", status: 404 });
                            objv.execute();
                        }
                    }
                    else {
                        let objv = new RawView_1.RawView(res);
                        objv.prepare({ message: "Something Went Wrong Find Records!", status: 502 });
                        objv.execute();
                    }
                });
            }
        });
    }
    getresellerlink(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                if (sessdata.type == 1) {
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    obj.qrysql = "Select srl.`iduser`,srl.`url`,srl.`created_at`,srl.`updated_at`,rp.`firstname`,rp.`lastname` From `signup_referral_link` srl JOIN `reseller_profile` rp ON srl.`iduser` = rp.`iduser`";
                    obj.prepare();
                    obj.execute((error1, result) => {
                        if (error1 == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 201, message: "Reseller Link Fetched Successfully!", data: result });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 502, message: "Something Went Wrong!" });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 503, message: "Service Unavailable!" });
                    objv.execute();
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
    getfilterdetails(req, res, next) {
        let session = new Session_1.SessionManagment(req, res, next);
        session.GetSession((error, sessdata) => {
            if (error == 1) {
                if (sessdata.type == 1) {
                    let data = req.body.data;
                    let conditions = [];
                    let obj = new RawQuery_1.ModelRawQuery(req, res);
                    if (data.resellerID) {
                        conditions.push('srl.`iduser` LIKE "%' + (0, markError_1.parseBody)(data.resellerID) + '%"');
                    }
                    if (data.from_date && data.to_date) {
                        conditions.push('srl.`created_at` BETWEEN "' + data.from_date + ' 00:00:00" AND "' + data.to_date + ' 23:59:59"');
                    }
                    let condition = conditions.length > 0 ? ' WHERE ' + conditions.join(' AND ') : '';
                    obj.qrysql = "Select srl.`iduser`,srl.`url`,srl.`created_at`,srl.`updated_at`,rp.`firstname`,rp.`lastname` From `signup_referral_link` srl JOIN `reseller_profile` rp ON srl.`iduser` = rp.`iduser`" + condition;
                    obj.prepare();
                    obj.execute((error1, result) => {
                        if (error1 == 1) {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({
                                status: 201, data: result, message: "Reseller Link List Fetched Successfully!"
                            });
                            objv.execute();
                        }
                        else {
                            let objv = new RawView_1.RawView(res);
                            objv.prepare({ status: 502, message: "Something Went Wrong With List!" });
                            objv.execute();
                        }
                    });
                }
                else {
                    let objv = new RawView_1.RawView(res);
                    objv.prepare({ status: 503, message: "Service Unavailable!" });
                    objv.execute();
                }
            }
            else {
                let objv = new _406_1.Res406(res);
                objv.prepare(session);
                objv.execute();
            }
        });
    }
}
exports.Reseller = Reseller;
