import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { TokensComponent } from './tokens/tokens.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: TokensComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'tokens',
                component: TokensComponent,
                data: {
                    title: 'API',
                    urls: [
                        {
                            title: 'API',
                        },
                        {
                            title: 'API Tokens'
                        }
                    ]
                }
            },
        ]
    }
];
let ApiRoutingModule = class ApiRoutingModule {
};
ApiRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], ApiRoutingModule);
export { ApiRoutingModule };
//# sourceMappingURL=api-routing.module.js.map