import { __decorate } from "tslib";
import { Component } from '@angular/core';
let VerifyemailComponent = class VerifyemailComponent {
    constructor(data, router, route) {
        this.data = data;
        this.router = router;
        this.route = route;
        this.errMessage = "";
        this.responseMessage = "";
        this.token = "";
        this.imageShow = '1';
    }
    ngOnInit() {
        this.imageShow = '1';
        this.route.paramMap.subscribe((params) => {
            let id = params.get('id');
            this.token = id;
            this.data.emailVerify({ key: this.token, isEmailVerify: true }).subscribe(res => {
                if (res.status == 201) {
                    this.imageShow = '1';
                    sessionStorage.clear();
                    let newData = res.data;
                    sessionStorage.setItem('isLoggedIn', JSON.stringify(newData));
                    sessionStorage.setItem('authkey', newData.authkey);
                    sessionStorage.setItem('type', newData.type);
                    sessionStorage.setItem('iduser', newData.iduser);
                    sessionStorage.setItem('email', res.email);
                    sessionStorage.setItem('username', newData.username);
                    sessionStorage.setItem('idaccount', newData.idaccount);
                    if (sessionStorage.getItem('isLoggedIn')) {
                        this.router.navigate(['/user/verify-profile']);
                    }
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.imageShow = '2';
                        this.errMessage = "";
                        //this.router.navigate(['/']);
                    }, 3000);
                }
            });
        });
    }
};
VerifyemailComponent = __decorate([
    Component({
        selector: 'app-verifyemail',
        templateUrl: './verifyemail.component.html',
        styleUrls: ['./verifyemail.component.css']
    })
], VerifyemailComponent);
export { VerifyemailComponent };
//# sourceMappingURL=verifyemail.component.js.map