import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let AccountledgerComponent = class AccountledgerComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.heading = [];
        this.main_heading = "";
    }
    ngOnInit() {
        this.data.getaccount().subscribe((result) => {
            this.account = result[0].header;
            this.rowdata = result[0].account_ledger;
            console.log(result);
            console.log(this.heading);
        });
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
AccountledgerComponent = __decorate([
    Component({
        selector: 'app-accountledger',
        templateUrl: './accountledger.component.html',
        styleUrls: ['./accountledger.component.css']
    })
], AccountledgerComponent);
export { AccountledgerComponent };
//# sourceMappingURL=accountledger.component.js.map