import { __decorate } from "tslib";
import { Pipe } from '@angular/core';
let FloorDecimal = class FloorDecimal {
    transform(value) {
        if (value == null || value == undefined) {
            return "";
        }
        else if (value < 0 || isNaN(Number(value))) {
            return "0";
        }
        else {
            return value.toFixed(4);
        }
    }
};
FloorDecimal = __decorate([
    Pipe({ name: 'decimal' })
], FloorDecimal);
export { FloorDecimal };
//# sourceMappingURL=decimal.pipe.js.map