import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let RatedecksComponent = class RatedecksComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
    }
    ngOnInit() {
        this.data.getratedeck().subscribe((result) => {
            this.header = result[0].headers;
            this.rowlist = result[0].rate_decks;
            console.log(result);
        });
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
RatedecksComponent = __decorate([
    Component({
        selector: 'app-ratedecks',
        templateUrl: './ratedecks.component.html',
        styleUrls: ['./ratedecks.component.css']
    })
], RatedecksComponent);
export { RatedecksComponent };
//# sourceMappingURL=ratedecks.component.js.map