import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let CnpCampaignComponent = class CnpCampaignComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        /* p: number = 1;
        page = 1;
        count = 0;
        tableSize = 25;
        tableSizes = [ 25, 50, 100]; */
        /* filterTerm: string;
        filterTerm1: string; */
        this.responseMessage = "";
        this.isCampaign = false;
        this.errMessage = "";
        this.campDid = [];
    }
    ngOnInit() {
        this.data.getcampaign().subscribe((result) => {
            this.collection = result[1];
            $.getScript('./assets/table.js');
            this.heading = result[0].headerCNP;
            this.main_heading = result[0].users;
        });
        this.data.GetCNPCampaignsList().subscribe(result => {
            if (result.status == 200) {
                var userID = this.data.iduser;
                if (result.data.length > 0) {
                    this.campaigns = result.data;
                    $.getScript('./assets/table.js');
                    this.isCampaign = true;
                }
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    getUser(camp, userid) {
        this.campaign_key = camp;
        const campaign_key = camp;
        const userID = userid;
        this.campDid = [];
        this.data.getCampaignDID(this.campaign_key, userID).subscribe((res) => {
            if (res.status == 200) {
                this.campDid = res.data;
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
};
CnpCampaignComponent = __decorate([
    Component({
        selector: 'app-cnp-campaign',
        templateUrl: './cnp-campaign.component.html',
        styleUrls: ['./cnp-campaign.component.css']
    })
], CnpCampaignComponent);
export { CnpCampaignComponent };
//# sourceMappingURL=cnp-campaign.component.js.map