import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { AddbrandComponent } from './addbrand/addbrand.component';
import { AddcampaignComponent } from './addcampaign/addcampaign.component';
import { BrandComponent } from './brand/brand.component';
import { BrandsComponent } from './brands/brands.component';
import { CampaignComponent } from './campaign/campaign.component';
import { MycampaignsComponent } from './mycampaigns/mycampaigns.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: MycampaignsComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'my-campaigns',
                component: MycampaignsComponent,
                data: {
                    title: 'My Campaigns',
                    urls: [
                        {
                            title: 'Campaigns',
                        },
                        {
                            title: 'My Campaigns'
                        }
                    ]
                }
            },
            {
                path: 'campaign',
                component: CampaignComponent,
                data: {
                    title: 'Campaign',
                    urls: [
                        {
                            title: 'Campaign',
                        },
                        {
                            title: 'Campaign'
                        }
                    ]
                }
            },
            {
                path: 'add-campaign',
                component: AddcampaignComponent,
                data: {
                    title: 'Campaign',
                    urls: [
                        {
                            title: 'Add-Campaign',
                        },
                        {
                            title: 'Add-Campaign'
                        }
                    ]
                }
            },
            {
                path: 'brands',
                component: BrandsComponent,
                data: {
                    title: 'Brnads',
                    urls: [
                        {
                            title: 'Campaigns',
                        },
                        {
                            title: 'Brnads'
                        }
                    ]
                }
            },
            {
                path: 'brand/:id',
                component: AddbrandComponent,
                data: {
                    title: 'Brand',
                    urls: [
                        {
                            title: 'Brand',
                        },
                        {
                            title: 'Brand'
                        }
                    ]
                }
            },
            {
                path: 'brand/brand/:id',
                component: BrandComponent,
                data: {
                    title: 'Brand',
                    urls: [
                        {
                            title: 'Brand',
                        },
                        {
                            title: 'Brand'
                        }
                    ]
                }
            },
        ]
    }
];
let CampaignsRoutingModule = class CampaignsRoutingModule {
};
CampaignsRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], CampaignsRoutingModule);
export { CampaignsRoutingModule };
//# sourceMappingURL=campaigns-routing.module.js.map