import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { ConnectionComponent } from './connection/connection.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: ConnectionComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'connection-details',
                component: ConnectionComponent,
                data: {
                    title: 'Connection Details',
                    urls: [
                        {
                            title: 'Connection Details',
                            //   url: '/connections/connection-details'
                        },
                        {
                            title: 'Connection'
                        }
                    ]
                }
            },
        ]
    }
];
let ConnectionsRoutingModule = class ConnectionsRoutingModule {
};
ConnectionsRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], ConnectionsRoutingModule);
export { ConnectionsRoutingModule };
//# sourceMappingURL=connections-routing.module.js.map