import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NgxPaginationModule } from 'ngx-pagination';
import { FormsModule } from '@angular/forms';
import { ConnectionsRoutingModule } from './connections-routing.module';
import { ConnectionComponent } from './connection/connection.component';
import { Ng2SearchPipeModule } from 'ng2-search-filter';
import { HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule } from '@angular/forms';
import { MatExpansionModule } from '@angular/material/expansion';
import { SharedModule } from '../shared/shared.module';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { EditConnectionComponent } from './edit-connection/edit-connection.component';
let ConnectionsModule = class ConnectionsModule {
};
ConnectionsModule = __decorate([
    NgModule({
        declarations: [ConnectionComponent, EditConnectionComponent],
        imports: [
            CommonModule,
            ConnectionsRoutingModule,
            NgxPaginationModule,
            Ng2SearchPipeModule,
            ReactiveFormsModule,
            SharedModule,
            MatSlideToggleModule,
            NgbModule,
            FormsModule,
            HttpClientModule,
            MatExpansionModule
        ],
        providers: []
    })
], ConnectionsModule);
export { ConnectionsModule };
//# sourceMappingURL=connections.module.js.map