import { __decorate } from "tslib";
import { Component } from '@angular/core';
let LocationComponent = class LocationComponent {
    constructor() { }
    ngOnInit() {
        $('#map-example').vectorMap({
            map: 'world_en',
            backgroundColor: 'transparent',
            borderColor: '#fff',
            borderWidth: 2,
            color: '#e4e4e4',
            enableZoom: true,
            hoverColor: '#35cd3a',
            hoverOpacity: null,
            normalizeFunction: 'linear',
            scaleColors: ['#b6d6ff', '#005ace'],
            selectedColor: '#35cd3a',
            selectedRegions: ['ID', 'RU', 'US', 'AU', 'CN', 'BR'],
            showTooltip: true,
            onRegionClick: function (element, code, region) {
                return false;
            }
        });
    }
};
LocationComponent = __decorate([
    Component({
        selector: 'app-location',
        templateUrl: './location.component.html',
        styleUrls: ['./location.component.css']
    })
], LocationComponent);
export { LocationComponent };
//# sourceMappingURL=location.component.js.map