import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { AppService } from '../shared/service/AppService.class';
let HomeService = class HomeService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    getData() {
        return this.http.get('./assets/jsonData/campaign.json');
    }
    getCampaignsInfo() {
        this.appmod = "lib/dashboardcampaign";
        return super.getService();
    }
    getLeadInfo(type, filter) {
        this.appmod = "reports/leads";
        return super.getService(type, filter);
    }
    getCallDial(type, filter) {
        this.appmod = "reports/calls";
        return super.getService(type, filter);
    }
    getISDNError(type, filter) {
        this.appmod = "reports/isdn";
        return super.getService(type, filter);
    }
    getLive(type, filter) {
        this.appmod = "reports/live";
        return super.getService(type, filter);
    }
    getLiveWidget() {
        this.appmod = "reports/livewidget";
        return super.getService();
    }
    getCallDist(type, filter) {
        this.appmod = "reports/dist";
        return super.getService(type, filter);
    }
    getCampaign() {
        this.appmod = "lib/optcampaign";
        return super.getService();
    }
    getChartReportData(sdata) {
        let tmp = this.appmod;
        this.appmod = "custom/get_chart_report_data";
        let data = this.saveService(sdata);
        this.appmod = tmp;
        return data;
    }
};
HomeService = __decorate([
    Injectable()
], HomeService);
export { HomeService };
//# sourceMappingURL=home.service.js.map