import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { FederalComponent } from './federal/federal.component';
import { FederalPdfComponent } from './federal-pdf/federal-pdf.component';
const routes = [
    {
        path: 'federal',
        component: FederalComponent,
        data: {
            title: 'federal',
            urls: [
                {
                    title: 'federal',
                },
                {
                    title: 'federal'
                }
            ]
        },
    },
    {
        path: 'federal-details',
        component: FederalPdfComponent,
        data: {
            title: 'federal-details',
            urls: [
                {
                    title: 'federal-details',
                }
            ]
        }
    },
    {
        path: "federal-details/:id",
        component: FederalPdfComponent,
        data: {
            title: "federal-details",
            urls: [
                {
                    title: 'federal-details',
                },
                {
                    title: 'federal-details'
                }
            ]
        }
    }
];
let FederalRoutingModule = class FederalRoutingModule {
};
FederalRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], FederalRoutingModule);
export { FederalRoutingModule };
//# sourceMappingURL=federal-routing.module.js.map