import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { SharedModule } from '../shared/shared.module';
import { FederalRoutingModule } from './federal-routing.module';
import { FederalComponent } from './federal/federal.component';
import { ReactiveFormsModule } from '@angular/forms';
import { FederalPdfComponent } from './federal-pdf/federal-pdf.component';
let FederalModule = class FederalModule {
};
FederalModule = __decorate([
    NgModule({
        declarations: [FederalComponent, FederalPdfComponent],
        imports: [
            CommonModule,
            FederalRoutingModule,
            SharedModule,
            ReactiveFormsModule
        ]
    })
], FederalModule);
export { FederalModule };
//# sourceMappingURL=federal.module.js.map