import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let InboundratesComponent = class InboundratesComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
    }
    ngOnInit() {
        this.data.getinboundrate().subscribe((result) => {
            this.header = result[0].headers;
            this.rowdata = result[0].inbound_rate;
            console.log(this.rowdata);
        });
        // $(document).ready(function() {
        // 	$('#basic-datatables').DataTable({
        // 	});
        // });
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
InboundratesComponent = __decorate([
    Component({
        selector: 'app-inboundrates',
        templateUrl: './inboundrates.component.html',
        styleUrls: ['./inboundrates.component.css']
    })
], InboundratesComponent);
export { InboundratesComponent };
//# sourceMappingURL=inboundrates.component.js.map