import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { managesiteForm } from '../inbound.class';
let ManagesitesComponent = class ManagesitesComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        // defaultSelect : any = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
    }
    // constructor(private Formbuilder: FormBuilder, private data: InboundService,) { 
    //   this.managesiteForm = this.Formbuilder.group({
    //     nick_name: [''],
    //     type: [''],
    //     address: [''],
    //     location: [''],
    //     country: [''],
    //     state: [''],
    //     city: [''],
    //     zip: [''],
    //   })
    // }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new managesiteForm(res);
                this.keyfield = res.id;
                this.managesiteForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new managesiteForm(null);
                this.keyfield = -1;
                this.managesiteForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.getmanagesite().subscribe((result) => {
            this.header = result[0].headers_details;
            this.listdata = result[0].sites_details;
            this.label = result[1];
            console.log(result);
        });
    }
    saveForm(data) {
        console.log(data, "data");
    }
    toggle() {
        this.show = !this.show;
        // CHANGE THE NAME OF THE BUTTON.
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
    // @to edit the record
    editRow(rowdata) {
        this.show = true;
        this.Edit(rowdata);
    }
    get f() { return this.managesiteForm.controls; }
    ;
    // @to save/update form data
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.managesiteForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.managesiteForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
ManagesitesComponent = __decorate([
    Component({
        selector: 'app-managesites',
        templateUrl: './managesites.component.html',
        styleUrls: ['./managesites.component.css']
    })
], ManagesitesComponent);
export { ManagesitesComponent };
//# sourceMappingURL=managesites.component.js.map