import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let UncompletecallComponent = class UncompletecallComponent extends AppComponentClass {
    constructor(fb, data, router) {
        super(data, router, fb);
        this.fb = fb;
        this.data = data;
        this.router = router;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.show = false;
        this.show1 = false;
        this.hide = false;
        this.uncompleteForm = this.fb.group({
            from_date: ['', [Validators.required]],
            to_date: ['', [Validators.required]],
            from_ani: ['', [Validators.required]],
            to_did: ['', [Validators.required]],
            call_id: ['', [Validators.required]],
        });
    }
    ngOnInit() {
        this.data.getuncomplete().subscribe((result) => {
            this.complete = result[1];
            this.header = result[0].headers_details;
            // this.listdata = result[0].complete_details;
            console.log(result);
        });
    }
    get f() { return this.uncompleteForm.controls; }
    ;
    onsubmit() {
        if (this.uncompleteForm.valid) {
            this.data.getuncomplete().subscribe((result) => {
                this.header = result[0].headers_details;
                // this.listdata = result[0].complete_details;
                // console.log(result)
                // console.log(this.listdata)
                let data = this.uncompleteForm.value;
                this.data.callDetails(this.uncompleteForm.valid).subscribe(result => {
                    console.log(result);
                });
                this.hide = !this.hide;
                console.log(data);
            });
        }
        else {
            return false;
        }
    }
    toggle() {
        this.show = !this.show;
    }
    tablehide() {
        // this.show1 = !this.show1;
        this.hide = !this.hide;
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
UncompletecallComponent = __decorate([
    Component({
        selector: 'app-uncompletecall',
        templateUrl: './uncompletecall.component.html',
        styleUrls: ['./uncompletecall.component.css']
    })
], UncompletecallComponent);
export { UncompletecallComponent };
//# sourceMappingURL=uncompletecall.component.js.map