import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let ReportComponent = class ReportComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.lineChartData = [
            { data: [65, 59, 80, 81, 56, 55, 40], label: 'Series A' },
        ];
        this.lineChartLabels = ['January', 'February', 'March', 'April', 'May', 'June', 'July'];
        this.lineChartColors = [
            {
                borderColor: 'blue',
                backgroundColor: 'transparent',
            },
        ];
        this.lineChartLegend = true;
        this.lineChartType = 'line';
        this.lineChartPlugins = [];
    }
    ngOnInit() {
    }
};
ReportComponent = __decorate([
    Component({
        selector: 'app-report',
        templateUrl: './report.component.html',
        styleUrls: ['./report.component.css']
    })
], ReportComponent);
export { ReportComponent };
//# sourceMappingURL=report.component.js.map