import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { ReportComponent } from './report/report.component';
import { TmobileComponent } from './tmobile/tmobile.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: ReportComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'report',
                component: ReportComponent,
                data: {
                    title: 'Reports',
                    urls: [
                        {
                            title: 'Reports',
                        },
                        {
                            title: 'Report'
                        }
                    ]
                }
            },
            {
                path: 't-mobile',
                component: TmobileComponent,
                data: {
                    title: 'Reports',
                    urls: [
                        {
                            title: 'Reports',
                        },
                        {
                            title: 't-mobile'
                        }
                    ]
                }
            },
        ]
    }
];
let ReportsRoutingModule = class ReportsRoutingModule {
};
ReportsRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], ReportsRoutingModule);
export { ReportsRoutingModule };
//# sourceMappingURL=reports-routing.module.js.map