import { __decorate, __param } from "tslib";
import { Component, Inject } from '@angular/core';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import { BehaviorSubject } from 'rxjs';
let DialogComponent = class DialogComponent {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.errMessage$ = new BehaviorSubject("");
        this.errMessage = this.errMessage$.asObservable();
        this.errMessage$.next(data.errorMessage);
    }
    ngOnInit() {
    }
    onClick() {
        this.dialogRef.close();
    }
};
DialogComponent = __decorate([
    Component({
        selector: 'app-dialog',
        templateUrl: './dialog.component.html',
        styleUrls: ['./dialog.component.css']
    }),
    __param(1, Inject(MAT_DIALOG_DATA))
], DialogComponent);
export { DialogComponent };
//# sourceMappingURL=dialog.component.js.map