import { __decorate } from "tslib";
import { Component, EventEmitter, Input, Output } from '@angular/core';
let DynamicformComponent = class DynamicformComponent {
    constructor(fb) {
        this.fb = fb;
        this.onSave = new EventEmitter();
        this.formFields = [];
        this.fields = {};
        this.newFormData = {};
    }
    ngOnInit() {
        console.log(this.editData);
        if (this.editData != undefined) {
            this.formData.subscribe(response => {
                this.formFields = response;
                this.formFields.forEach(element => {
                    this.fields[element.formControl] = [];
                });
            });
            this.dynamicForm.patchValue(this.editData);
        }
        else {
            this.formData.subscribe(response => {
                this.formFields = response;
                this.formFields.forEach(element => {
                    this.fields[element.formControl] = [];
                });
            });
            this.dynamicForm = this.fb.group(this.fields);
        }
    }
    onAddForm() {
        this.onSave.emit(this.dynamicForm.value);
    }
};
__decorate([
    Input()
], DynamicformComponent.prototype, "formData", void 0);
__decorate([
    Input()
], DynamicformComponent.prototype, "editData", void 0);
__decorate([
    Output()
], DynamicformComponent.prototype, "onSave", void 0);
DynamicformComponent = __decorate([
    Component({
        selector: 'app-dynamicform',
        templateUrl: './dynamicform.component.html',
        styleUrls: ['./dynamicform.component.css']
    })
], DynamicformComponent);
export { DynamicformComponent };
//# sourceMappingURL=dynamicform.component.js.map