import { environment } from '../../../environments/environment';
import { AppData } from '../../shared/service/AppData.class';
export class AppComponentReport extends AppData {
    constructor(data, router) {
        super(router);
        this.data = data;
        this.router = router;
        this.debug = environment.production;
    }
    debug_log(log) {
        if (!this.debug) { }
    }
    ngOnInit() {
        this.data.getReport(this.leadid).subscribe(res => {
            this.debug_log(res.toString());
        });
    }
    applyFilter(filterValue) {
        filterValue = filterValue.trim();
        filterValue = filterValue.toLowerCase();
    }
}
//# sourceMappingURL=AppComponent.Report.js.map