import { ChildActivationEnd } from "@angular/router";
import { environment } from '../../../environments/environment';
import { filter, take } from 'rxjs/operators';
import { BehaviorSubject } from "rxjs";
export class AppComponentClass {
    //////@for role permissions//////
    constructor(data, router, fb, aRoute, snackBar) {
        var _a, _b, _c, _d;
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.aRoute = aRoute;
        this.snackBar = snackBar;
        this.debug = environment.production;
        //////@for role permissions//////
        this.permissions = {};
        this.user_type = 0;
        this.user_key = "";
        this.role_type = 0;
        this.userData = {};
        this.userid = parseInt((_a = this.userData) === null || _a === void 0 ? void 0 : _a.id); //localStorage.getItem('userid')
        this.keyfield = -1;
        this.amount = null;
        this.pkgselected = -1;
        //////@for role permissions//////
        this.user_type = parseInt((_b = this.userData) === null || _b === void 0 ? void 0 : _b.role_type); //localStorage.getItem("type")
        this.user_key = ((_c = this.userData) === null || _c === void 0 ? void 0 : _c.role_key) || ""; //localStorage.getItem("role_key")
        this.role_type = parseInt((_d = this.userData) === null || _d === void 0 ? void 0 : _d.role_type); //sessionStorage.getItem("role_type")
        this.router.events.pipe(filter(event => event instanceof ChildActivationEnd), take(1)).subscribe((e) => {
            var _a, _b, _c, _d, _e, _f;
            if (typeof ((_b = (_a = e.snapshot) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.permissions) != 'undefined' && Array.isArray((_d = (_c = e.snapshot) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.permissions)) {
                let modules = (_f = (_e = e.snapshot) === null || _e === void 0 ? void 0 : _e.data) === null || _f === void 0 ? void 0 : _f.permissions;
                for (let x of modules)
                    [
                        this.permissions[x.mod_short_key] = {
                            exec_w: x.exec_w,
                            exec_r: x.exec_r,
                            exec_x: x.exec_x
                        }
                    ];
            }
        });
        //////@for role permissions//////
        // this.userData = this?.router?.config[1]?.data?.sessdata.gSDt
    }
    getRouteData() {
        var _a, _b, _c, _d;
        let tmp = new BehaviorSubject(null);
        (_d = (_c = (_b = (_a = this === null || this === void 0 ? void 0 : this.router) === null || _a === void 0 ? void 0 : _a.config[1]) === null || _b === void 0 ? void 0 : _b.data) === null || _c === void 0 ? void 0 : _c.gvdata) === null || _d === void 0 ? void 0 : _d.getData().subscribe(res => {
            tmp.next(res);
        });
        return tmp;
    }
    setRouteData(data) {
        var _a, _b, _c, _d;
        (_d = (_c = (_b = (_a = this === null || this === void 0 ? void 0 : this.router) === null || _a === void 0 ? void 0 : _a.config[1]) === null || _b === void 0 ? void 0 : _b.data) === null || _c === void 0 ? void 0 : _c.gvdata) === null || _d === void 0 ? void 0 : _d.setData(data);
    }
    /*getMute(): Observable<any> {
      let tmp = new BehaviorSubject<any>(null);
      this?.router?.config[1]?.data?.gvdata?.getMute().subscribe(res => {
        tmp.next(res)
      });
      return tmp;
    }
  
    setMute(data: any) {
      this?.router?.config[1]?.data?.gvdata?.setMute(data)
    }
  
    getHold(): Observable<any> {
      let tmp = new BehaviorSubject<any>(null);
      this?.router?.config[1]?.data?.gvdata?.getHold().subscribe(res => {
        tmp.next(res)
      });
      return tmp;
    }
  
    setHold(data: any) {
      this?.router?.config[1]?.data?.gvdata?.setHold(data)
    }
  
    getCalling(): Observable<any> {
      let tmp = new BehaviorSubject<any>(null);
      this?.router?.config[1]?.data?.gvdata?.getCalling().subscribe(res => {
        tmp.next(res)
      });
      return tmp;
    }
  
    setCalling(data: any) {
      this?.router?.config[1]?.data?.gvdata?.setCalling(data)
    }*/
    // getRouteData(): Observable<any> {
    //   let tmp = new BehaviorSubject<any>(null);
    //   this.router.events.pipe(
    //     filter(event => event instanceof ChildActivationEnd),
    //     take(1),
    //   ).subscribe((e: ChildActivationEnd) => {
    //     tmp.next(e.snapshot.data.gvdata.getData());
    //   });
    //   return tmp;
    // }
    // setRouteData(data: any) {
    //   this.router.events.pipe(
    //     filter(event => event instanceof ChildActivationEnd),
    //     take(1),
    //   ).subscribe((e: ChildActivationEnd) => {
    //     e.snapshot.data.gvdata.setData(data);
    //   });
    // }
    // @it will print debug log of submitted form
    debug_log(log) {
        if (!this.debug) { }
    }
    ngOnInit() {
        this.data.frm_label.subscribe(res => {
            this.tag_label = res;
        });
        this.data.status.subscribe(res => {
            this.state = res;
        });
        //  this.loadDataSource();
    }
    nextButtonClickEvent() {
        //do next particular records like  101 - 200 rows.
        //we are calling to api
    }
    // loadDataSource() {
    //   this.data.getService().subscribe(res => {
    //     // this.debug_log(res.toString());
    //     this.dataSource = res;
    //   });
    // }
    // @to edit the current row data
    Edit(row) {
        this.data.changelabel("Edit Details");
        this.data.Data = row;
        this.data.changefrm(true);
    }
    // @to delete the current row data
    Delete(id) {
        this.openSnackBar("Data is deleted successfully", "Clear");
    }
    // @it will submit form-data
    onSubmit() {
        this.debug_log("Thanks for submitting! Data: " + JSON.stringify(this.cdata));
        this.debug_log(this.keyfield.toString());
        if (this.keyfield == -1) {
            this.data.saveService(JSON.stringify(this.cdata)).subscribe(rs => {
                this.data.changefrm(false);
                this.openSnackBar("Data is added successfully", "Clear");
                this.data.changelabel("List Details");
            });
        }
        else {
            this.data.updateService(JSON.stringify(this.cdata), this.keyfield).subscribe(rs => {
                this.data.changefrm(false);
                this.data.Data = null;
                this.data.changelabel("List Details");
            });
        }
    }
    openSnackBar(message, action) {
        this.snackBar.open(message, action, {
            duration: 2000,
        });
    }
    // @get current date-time
    current_datetime() {
        let now = new Date(), year = "" + now.getFullYear(), month = "" + (now.getMonth() + 1), day = "" + now.getDate(), hour = "" + now.getHours(), minute = "" + now.getMinutes(), second = "" + now.getSeconds();
        month = (month.length == 1) ? "0" + month : month;
        day = (day.length == 1) ? day = "0" + day : day;
        hour = (hour.length == 1) ? hour = "0" + hour : hour;
        minute = (minute.length == 1) ? minute = "0" + minute : minute;
        second = (second.length == 1) ? second = "0" + second : second;
        return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second;
    }
    // @unsubscribe observable behaviour on ngDestroy
    onDestroy() {
        this.data.frm_label.unsubscribe();
    }
}
//# sourceMappingURL=AppComponent.class.js.map