import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { EmailtemplateComponent } from './emailtemplate/emailtemplate.component';
import { EmailtemplatedetailsComponent } from './emailtemplatedetails/emailtemplatedetails.component';
import { MmsComponent } from './mms/mms.component';
import { MmstemplateComponent } from './mmstemplate/mmstemplate.component';
import { SmstemplateComponent } from './smstemplate/smstemplate.component';
import { SmstemplatedetailsComponent } from './smstemplatedetails/smstemplatedetails.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: EmailtemplateComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'email-template',
                component: EmailtemplateComponent,
                data: {
                    title: 'Email Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'Email Template'
                        }
                    ]
                }
            },
            {
                path: 'email-template/:id',
                component: EmailtemplateComponent,
                data: {
                    title: 'Email Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'Email Template'
                        }
                    ]
                }
            },
            // {
            //     path: 'factor-authentication',
            //     component: FactorauthenticationComponent,
            //     data: {
            //         title: 'Factor Authentication',
            //         urls: [
            //             {
            //                 title: 'Template',
            //             },
            //             {
            //                 title: 'factor authentication'
            //             }
            //         ]
            //     }
            //   },
            //   {
            //     path: 'factor-authentication/:id',
            //     component: FactorauthenticationComponent,
            //     data: {
            //         title: 'Factor Authentication',
            //         urls: [
            //             {
            //                 title: 'Template',
            //             },
            //             {
            //                 title: 'factor authentication'
            //             }
            //         ]
            //     }
            //   },
            //   {
            //     path: 'factor-authentication-details',
            //     component: FactorauthenticationdetailsComponent,
            //     data: {
            //         title: 'Factor Authentication Details',
            //         urls: [
            //             {
            //                 title: 'Template',
            //             },
            //             {
            //                 title: 'factor authentication details'
            //             }
            //         ]
            //     }
            //   },
            {
                path: 'sms-template',
                component: SmstemplateComponent,
                data: {
                    title: 'SMS Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'SMS Template'
                        }
                    ]
                }
            },
            {
                path: 'sms-template/:id',
                component: SmstemplateComponent,
                data: {
                    title: 'SMS Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'SMS Template'
                        }
                    ]
                }
            },
            {
                path: 'sms-template-details',
                component: SmstemplatedetailsComponent,
                data: {
                    title: 'SMS Template Details',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'SMS Template Details'
                        }
                    ]
                }
            },
            {
                path: 'email-template-details',
                component: EmailtemplatedetailsComponent,
                data: {
                    title: 'Email Template Details',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'Email Template Details'
                        }
                    ]
                }
            },
            {
                path: 'mms',
                component: MmsComponent,
                data: {
                    title: 'MMS Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'MMS Template'
                        }
                    ]
                }
            },
            {
                path: 'mms-template',
                component: MmstemplateComponent,
                data: {
                    title: 'MMS Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'MMS Template'
                        }
                    ]
                }
            },
            {
                path: 'mms-template/:id',
                component: MmstemplateComponent,
                data: {
                    title: 'MMS Template',
                    urls: [
                        {
                            title: 'Template',
                        },
                        {
                            title: 'MMS Template'
                        }
                    ]
                }
            },
        ]
    }
];
let SignuptemplateRoutingModule = class SignuptemplateRoutingModule {
};
SignuptemplateRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], SignuptemplateRoutingModule);
export { SignuptemplateRoutingModule };
//# sourceMappingURL=signuptemplate-routing.module.js.map