import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let SmssettingComponent = class SmssettingComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
    }
    ngOnInit() {
        this.smssettingForm = this.fb.group({
            otp_digit: ['', Validators.required],
            message_body: ['', Validators.required],
        });
    }
    onSubmit() {
        this.smssettingForm.value;
        console.log(this.smssettingForm.value);
    }
};
SmssettingComponent = __decorate([
    Component({
        selector: 'app-smssetting',
        templateUrl: './smssetting.component.html',
        styleUrls: ['./smssetting.component.css']
    })
], SmssettingComponent);
export { SmssettingComponent };
//# sourceMappingURL=smssetting.component.js.map