import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { SupplierComponent } from './supplier/supplier.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: SupplierComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'supplier',
                component: SupplierComponent,
                data: {
                    title: 'Supplier Management',
                    urls: [
                        {
                            title: 'Supplier',
                            //   url: 'supplier'
                        },
                        {
                            title: 'Supplier Management'
                        }
                    ]
                }
            },
        ]
    }
];
let SuppliermanagementRoutingModule = class SuppliermanagementRoutingModule {
};
SuppliermanagementRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], SuppliermanagementRoutingModule);
export { SuppliermanagementRoutingModule };
//# sourceMappingURL=suppliermanagement-routing.module.js.map