import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let TierComponent = class TierComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.showMsg = false;
        this.p = 1;
        // defaultSelect : any = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
        this.fileToUpload = null;
    }
    ngOnInit() {
        this.data.gettier().subscribe((result) => {
            this.listdata = result[0].headers;
            this.row = result[0].invoice;
            console.log(this.listdata);
        });
        this.data.getrecord().subscribe((result) => {
            this.record = result[0].headers_details;
            this.list = result[0].profile_details;
            console.log(this.list);
        });
    }
    onSubmit() {
        console.log("data", this.tiermanagementForm);
    }
    downloadMyFile() {
        this.data
            .download('./assets/sample-csv/ratelist-sample.csv')
            .subscribe(blob => {
            const a = document.createElement('a');
            const objectUrl = URL.createObjectURL(blob);
            a.href = objectUrl;
            a.download = 'ratelist-sample.csv';
            a.click();
            URL.revokeObjectURL(objectUrl);
        });
    }
    handleFileInput(files) {
        let sessionid = 32;
        let filetype = "agent guide";
        files.item(0)["sessionid"] = sessionid;
        files.item(0)["filetyepe"] = filetype;
        this.fileToUpload = files.item(0);
        console.log(files.item(0));
        this.data.postFile(this.fileToUpload, sessionid, filetype).subscribe(res => {
            console.log(res);
            this.file = res.filename;
            console.log("check1");
        }, error => {
            console.log(error);
        });
    }
};
TierComponent = __decorate([
    Component({
        selector: 'app-tier',
        templateUrl: './tier.component.html',
        styleUrls: ['./tier.component.css']
    })
], TierComponent);
export { TierComponent };
//# sourceMappingURL=tier.component.js.map