import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TiermanagementService } from './tiermanagement.service';
import { TiermanagementRoutingModule } from './tiermanagement-routing.module';
import { TierComponent } from './tier/tier.component';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { FormsModule } from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import { RatemanagementComponent } from './ratemanagement/ratemanagement.component';
let TiermanagementModule = class TiermanagementModule {
};
TiermanagementModule = __decorate([
    NgModule({
        declarations: [TierComponent, RatemanagementComponent,],
        imports: [
            CommonModule,
            TiermanagementRoutingModule,
            ReactiveFormsModule,
            FormsModule,
            NgbModule
        ],
        providers: [TiermanagementService]
    })
], TiermanagementModule);
export { TiermanagementModule };
//# sourceMappingURL=tiermanagement.module.js.map