import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { environment } from 'src/environments/environment';
let TiermanagementService = class TiermanagementService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    saveData(data) {
        let tmp = this.appmod;
        this.appmod = 'tier/save_rate';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    updateData(data) {
        let tmp = this.appmod;
        this.appmod = 'tier/update_rate';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getFeature() {
        return this.http.get(environment.SERVER + 'tier/get_feature');
    }
    gettier() {
        return this.http.get('./assets/tier.json');
    }
    getrecord() {
        return this.http.get('./assets/tierreports.json');
    }
    postFile(fileToUpload, sessionid, filetype) {
        console.log("check2");
        console.log(sessionid);
        console.log(filetype);
        const endpoint = environment.SERVER + 'uploads/rate_csv';
        const formData = new FormData();
        console.log(formData);
        formData.append('fileKey', fileToUpload, fileToUpload.name);
        formData.append('filetype', filetype);
        formData.append('sessionid', sessionid);
        console.log(fileToUpload);
        //console.log(fileToUpload.sessionid);
        let httpHeaders = new HttpHeaders();
        return this.http
            .post(endpoint, formData, { headers: httpHeaders });
        //  .map(() => { return true; })
        //  .catch((e) => this.handleError(e));
    }
    download(url) {
        return this.http.get(url, {
            responseType: 'blob'
        });
    }
};
TiermanagementService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], TiermanagementService);
export { TiermanagementService };
//# sourceMappingURL=tiermanagement.service.js.map