import { __decorate } from "tslib";
import { Pipe } from "@angular/core";
let FormatTimePipe = class FormatTimePipe {
    transform(value) {
        const hours = Math.floor(value / 3600);
        const minutes = Math.floor((value % 3600) / 60);
        return ('00' + hours).slice(-2) + ':' + ('00' + minutes).slice(-2) + ':' + ('00' + Math.floor(value - minutes * 60)).slice(-2);
    }
};
FormatTimePipe = __decorate([
    Pipe({
        name: 'formatTime'
    })
], FormatTimePipe);
export { FormatTimePipe };
//# sourceMappingURL=dateformat.js.map