import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { LoaderEnabled } from '../shared/loader/loader.service';
import { environment } from 'src/environments/environment';
import { HttpHeaders } from '@angular/common/http';
let VoltLoginService = class VoltLoginService {
    constructor(http) {
        this.http = http;
    }
    logintoVolt(data) {
        const apiURL = environment.SERVER + 'logintoVolt';
        let httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
        return this.http.put(apiURL, data, { headers: httpHeaders });
    }
};
__decorate([
    LoaderEnabled()
], VoltLoginService.prototype, "logintoVolt", null);
VoltLoginService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], VoltLoginService);
export { VoltLoginService };
//# sourceMappingURL=volt-login.service.js.map