import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from 'src/app/shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
let WebhookService = class WebhookService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.httpHeaders = new HttpHeaders({
            "Content-Type": "application/json"
        });
    }
    getWebhookCategory() {
        this.appmod = 'webhookCategory';
        let result = super.getService();
        this.appmod = "";
        return result;
    }
    geteventType(data) {
        this.appmod = 'geteventType';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    getWebhook(data) {
        this.appmod = 'getWebhook';
        let result = super.getService(data);
        this.appmod = "";
        return result;
    }
    addWebhook(data) {
        this.appmod = 'addWebhook';
        let result = super.saveService(data);
        this.appmod = "";
        return result;
    }
    updateWebhook(id) {
        this.appmod = 'updateWebhook';
        let result = super.updateService(id);
        this.appmod = "";
        return result;
    }
    deleteWebhook(data) {
        this.appmod = 'deleteWebhook';
        let result = super.deleteService(data);
        this.appmod = "";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], WebhookService.prototype, "getWebhookCategory", null);
__decorate([
    LoaderEnabled()
], WebhookService.prototype, "geteventType", null);
__decorate([
    LoaderEnabled()
], WebhookService.prototype, "getWebhook", null);
__decorate([
    LoaderEnabled()
], WebhookService.prototype, "addWebhook", null);
__decorate([
    LoaderEnabled()
], WebhookService.prototype, "updateWebhook", null);
__decorate([
    LoaderEnabled()
], WebhookService.prototype, "deleteWebhook", null);
WebhookService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], WebhookService);
export { WebhookService };
//# sourceMappingURL=webhook.service.js.map