import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { WhitelabelComponent } from './whitelabel/whitelabel.component';
import { WhitelabeldetailsComponent } from './whitelabeldetails/whitelabeldetails.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: WhitelabelComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'whitelabel/:id',
                component: WhitelabelComponent,
                data: {
                    title: 'Whitelabel',
                    urls: [
                        {
                            title: 'Whitelabel',
                            // url: 'user-profile'
                        },
                        {
                            title: 'White Label'
                        }
                    ]
                }
            },
            {
                path: 'whitelabel-details',
                component: WhitelabeldetailsComponent,
                data: {
                    title: 'Whitelabel Details',
                    urls: [
                        {
                            title: 'Whitelabel',
                            // url: 'user-profile'
                        },
                        {
                            title: 'Whitelabel Details'
                        }
                    ]
                }
            },
        ]
    }
];
let WhitelabelRoutingModule = class WhitelabelRoutingModule {
};
WhitelabelRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], WhitelabelRoutingModule);
export { WhitelabelRoutingModule };
//# sourceMappingURL=whitelabel-routing.module.js.map