import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ReactiveFormsModule } from '@angular/forms';
import { ApiRoutingModule } from './api-routing.module';
import { TokensComponent } from './tokens/tokens.component';
import { ApiService } from './api.service';
import { Ng2SearchPipeModule } from 'ng2-search-filter';
import { FormsModule } from '@angular/forms';
import { NgxPaginationModule } from 'ngx-pagination';
import { MatTableModule } from '@angular/material/table';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { AddtokenComponent } from './addtoken/addtoken.component';
import { MatDialogModule } from '@angular/material/dialog';
import { SharedModule } from '../shared/shared.module';
import { MatTooltipModule } from '@angular/material/tooltip';
import { ClipboardModule } from '@angular/cdk/clipboard';
import { DemoMaterialModule } from '../demo-material-module';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
let ApiModule = class ApiModule {
};
ApiModule = __decorate([
    NgModule({
        declarations: [TokensComponent, AddtokenComponent],
        imports: [
            CommonModule,
            MatSlideToggleModule,
            Ng2SearchPipeModule,
            FormsModule,
            NgbModule,
            NgxPaginationModule,
            ApiRoutingModule,
            ReactiveFormsModule,
            MatTableModule,
            MatPaginatorModule,
            MatDialogModule,
            SharedModule,
            MatTooltipModule,
            ClipboardModule,
            DemoMaterialModule
        ],
        providers: [
            ApiService
        ]
    })
], ApiModule);
export { ApiModule };
//# sourceMappingURL=api.module.js.map