import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { AppService } from 'src/app/shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
let ApiService = class ApiService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    getApiToken() {
        this.appmod = "apiToken";
        let result = this.getService();
        this.appmod = "";
        return result;
    }
    saveToken(data) {
        let tmp = this.appmod;
        this.appmod = 'apiToken';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    onDeleteApiToken(id) {
        this.appmod = "apiToken";
        let result = this.deleteService(id);
        this.appmod = "";
        return result;
    }
    // @LoaderEnabled()
    subCustomers() {
        this.appmod = "subcustomers";
        let result = this.getService();
        this.appmod = "";
        return result;
    }
    get_apitoken() {
        return this.http.get('./assets/api_token.json');
    }
};
__decorate([
    LoaderEnabled()
], ApiService.prototype, "getApiToken", null);
__decorate([
    LoaderEnabled()
], ApiService.prototype, "saveToken", null);
__decorate([
    LoaderEnabled()
], ApiService.prototype, "onDeleteApiToken", null);
ApiService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ApiService);
export { ApiService };
//# sourceMappingURL=api.service.js.map