import { __decorate } from "tslib";
import { Component } from '@angular/core';
let DeleteUserComponent = class DeleteUserComponent {
    constructor(location, activatedRoute, router, data, authService) {
        this.location = location;
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.data = data;
        this.authService = authService;
        this.responseMessage = "";
        this.errMessage = "";
        this.isDeleted = '2';
        this.checkdelete = false;
        this.returnsms = false;
        this.btnName = "Delete My Account";
        let isLoggedIn = sessionStorage.getItem("isLoggedIn");
        this.sesiduser = JSON.parse(isLoggedIn);
        if (!this.sesiduser.iduser) {
            this.router.navigateByUrl('/login');
        }
    }
    ngOnInit() {
        this.btnName = "Delete My Account";
        history.pushState(null, null, window.location.href);
        // check if back or forward button is pressed.
        this.Location.onPopState(() => {
            history.pushState(null, null, window.location.href);
            this.stepper.previous();
        });
    }
    onDelAccount() {
        //this.btnName="InProcess...";
        this.data.getSingleUsers().subscribe(res => {
            if (res.status == 200) {
                // this.btnName="InProcess...";
                this.userdata = res.data1[0];
                if ((this.userdata.isEmailVerify == 'true' && this.userdata.isMobileVerify == 'true') && (this.userdata.isAddress == 'true' && this.userdata.isPlan == 'true')) {
                    this.isDeleted = 1; // onboarding completed
                }
                else {
                    this.isDeleted = 2; // onboarding not completed
                }
                this.data1 = {
                    sesiduser: this.sesiduser.iduser,
                    sesidaccount: this.sesiduser.idaccount,
                    isDeleted: this.isDeleted
                };
                if (!this.data1.sesiduser || !this.data1.isDeleted) {
                    return;
                }
                else {
                    this.btnName = "InProcess...";
                    this.data.onDeleteAccount(this.data1).subscribe((res) => {
                        if (res.status == 201) {
                            //this.btnName="Delete My Account";
                            this.responseMessage = res.message;
                            setTimeout(() => {
                                this.responseMessage = "";
                            }, 3000);
                            setTimeout(() => {
                                localStorage.clear();
                                sessionStorage.clear();
                                this.router.navigate(['/restore-account']);
                            }, 5000);
                        }
                        else {
                            this.btnName = "Delete My Account";
                            this.errMessage = res.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 4000);
                        }
                    });
                }
            }
        });
    }
};
DeleteUserComponent = __decorate([
    Component({
        selector: 'app-delete-user',
        templateUrl: './delete-user.component.html',
        styleUrls: ['./delete-user.component.css']
    })
], DeleteUserComponent);
export { DeleteUserComponent };
//# sourceMappingURL=delete-user.component.js.map