import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
let LockscreenComponent = class LockscreenComponent {
    constructor(fb, router) {
        this.fb = fb;
        this.router = router;
    }
    ngOnInit() {
        this.form = this.fb.group({
            uname: [null, Validators.compose([Validators.required])]
        });
    }
    onSubmit() {
        this.router.navigate(['/']);
    }
};
LockscreenComponent = __decorate([
    Component({
        selector: 'app-lockscreen',
        templateUrl: './lockscreen.component.html',
        styleUrls: ['./lockscreen.component.scss']
    })
], LockscreenComponent);
export { LockscreenComponent };
//# sourceMappingURL=lockscreen.component.js.map