import { __decorate } from "tslib";
import { Pipe } from "@angular/core";
let OrderPipe = class OrderPipe {
    transform(array, field) {
        array.sort((a, b) => {
            if (a[field] < b[field]) {
                return -1;
            }
            else if (a[field] > b[field]) {
                return 1;
            }
            else {
                return 0;
            }
        });
        return array;
    }
};
OrderPipe = __decorate([
    Pipe({
        name: "orderBy"
    })
], OrderPipe);
export { OrderPipe };
//# sourceMappingURL=orderPipe.pipe.js.map