import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let BrandsComponent = class BrandsComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.brands = [];
        this.errMessage = "";
    }
    ngOnInit() {
        this.data.get_brands().subscribe((result) => {
            this.header = result[0].headers;
        });
        this.data.getBrand().subscribe(result => {
            if (result.status == 200) {
                this.brands = result.data;
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
};
BrandsComponent = __decorate([
    Component({
        selector: 'app-brands',
        templateUrl: './brands.component.html',
        styleUrls: ['./brands.component.css']
    })
], BrandsComponent);
export { BrandsComponent };
//# sourceMappingURL=brands.component.js.map