import { __decorate } from "tslib";
import { Component } from '@angular/core';
let IncomeComponent = class IncomeComponent {
    constructor() { }
    ngOnInit() {
        var totalIncomeChart2 = document.getElementById('totalIncomeChart2');
        var mytotalIncomeChart2 = new Chart(totalIncomeChart2, {
            type: 'bar',
            data: {
                labels: ["S", "M", "T", "W", "T", "F", "S", "S", "M", "T"],
                datasets: [{
                        label: "Total Income",
                        backgroundColor: '#ff9e27',
                        borderColor: 'rgb(23, 125, 255)',
                        data: [6, 4, 9, 5, 4, 6, 4, 3, 8, 10],
                    }],
            },
            options: {
                responsive: true,
                maintainAspectRatio: false,
                legend: {
                    display: false,
                },
                scales: {
                    yAxes: [{
                            ticks: {
                                display: false //this will remove only the label
                            },
                            gridLines: {
                                drawBorder: false,
                                display: false
                            }
                        }],
                    xAxes: [{
                            gridLines: {
                                drawBorder: false,
                                display: false
                            }
                        }]
                },
            }
        });
    }
};
IncomeComponent = __decorate([
    Component({
        selector: 'app-income',
        templateUrl: './income.component.html',
        styleUrls: ['./income.component.css']
    })
], IncomeComponent);
export { IncomeComponent };
//# sourceMappingURL=income.component.js.map