import { __decorate } from "tslib";
import { Component } from '@angular/core';
let InformationComponent = class InformationComponent {
    constructor() { }
    ngOnInit() {
        "use strict";
        // Cicle Chart
        Circles.create({
            id: 'task-complete',
            radius: 50,
            value: 80,
            maxValue: 100,
            width: 5,
            text: function (value) { return value + '%'; },
            colors: ['#36a3f7', '#fff'],
            duration: 400,
            wrpClass: 'circles-wrp',
            textClass: 'circles-text',
            styleWrapper: true,
            styleText: true
        });
        Circles.create({
            id: 'circles-1',
            radius: 45,
            value: 60,
            maxValue: 100,
            width: 7,
            text: 5,
            colors: ['#f1f1f1', '#FF9E27'],
            duration: 400,
            wrpClass: 'circles-wrp',
            textClass: 'circles-text',
            styleWrapper: true,
            styleText: true
        });
        Circles.create({
            id: 'circles-2',
            radius: 45,
            value: 70,
            maxValue: 100,
            width: 7,
            text: 36,
            colors: ['#f1f1f1', '#2BB930'],
            duration: 400,
            wrpClass: 'circles-wrp',
            textClass: 'circles-text',
            styleWrapper: true,
            styleText: true
        });
        Circles.create({
            id: 'circles-3',
            radius: 45,
            value: 40,
            maxValue: 100,
            width: 7,
            text: 12,
            colors: ['#f1f1f1', '#F25961'],
            duration: 400,
            wrpClass: 'circles-wrp',
            textClass: 'circles-text',
            styleWrapper: true,
            styleText: true
        });
    }
};
InformationComponent = __decorate([
    Component({
        selector: 'app-information',
        templateUrl: './information.component.html',
        styleUrls: ['./information.component.css']
    })
], InformationComponent);
export { InformationComponent };
//# sourceMappingURL=information.component.js.map