import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { Validators } from '@angular/forms';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let CompletecallComponent = class CompletecallComponent extends AppComponentClass {
    constructor(fb, data, router) {
        super(data, router, fb);
        this.fb = fb;
        this.data = data;
        this.router = router;
        this.p = 1;
        this.page = 1;
        this.count = 0;
        this.tableSize = 5;
        this.tableSizes = [5, 9, 12];
        this.show = false;
        this.show1 = false;
        this.hide = false;
        this.completeForm = this.fb.group({
            from_date: ['', Validators.required],
            to_date: ['', Validators.required],
            to_did: ['', Validators.required],
            call_id: ['', Validators.required],
        });
    }
    ngOnInit() {
        this.data.getcomplete().subscribe((result) => {
            this.complete = result[1];
            // this.header = result[0].headers_details;
            // this.listdata = result[0].complete_details;
            console.log(result);
        });
    }
    get f() { return this.completeForm.controls; }
    ;
    onsubmit() {
        this.submitted = true;
        if (this.completeForm.valid) {
            let data = this.completeForm.value;
            console.log(data);
            this.data.getcomplete().subscribe((result) => {
                this.header = result[0].headers_details;
                // this.listdata = result[0].complete_details;
                // console.log(this.listdata)
                this.data.callDetails(data).subscribe(result => {
                    console.log("result::", result);
                });
                this.hide = !this.hide;
            });
            // this.data.callDetails(this.completeForm.valid).subscribe(result=>{
            //   console.log("result::", result)
            // })
        }
        else {
            return false;
        }
    }
    toggle() {
        this.show = !this.show;
    }
    tablehide() {
        // this.show1 = !this.show1;
        this.hide = !this.hide;
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
};
CompletecallComponent = __decorate([
    Component({
        selector: 'app-completecall',
        templateUrl: './completecall.component.html',
        styleUrls: ['./completecall.component.css']
    })
], CompletecallComponent);
export { CompletecallComponent };
//# sourceMappingURL=completecall.component.js.map