var DidComponent_1;
import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { FormControl, Validators } from '@angular/forms';
import { BehaviorSubject } from 'rxjs';
import { trigger, transition, style, animate, state } from '@angular/animations';
import * as XLSX from 'xlsx';
import { saveAs } from 'file-saver';
import { formatDate } from '@angular/common';
let DidComponent = DidComponent_1 = class DidComponent extends AppComponentClass {
    constructor(data, router, fb, userService, ConnectionService, campService) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.userService = userService;
        this.ConnectionService = ConnectionService;
        this.campService = campService;
        this.searchText = { count: 0 };
        this.page = 1;
        this.count = 0;
        this.tableSize = 10;
        this.tableSizes = [10, 20, 50, 100];
        this.responseMessage = "";
        this.errMessage = "";
        this.dids = [];
        this.didCount = [];
        this.tab1$ = new BehaviorSubject("");
        this.tab1 = this.tab1$.asObservable();
        this.tab1Value = "";
        this.tab2$ = new BehaviorSubject("");
        this.tab2 = this.tab1$.asObservable();
        this.tab2Value = "";
        this.tab3$ = new BehaviorSubject("");
        this.tab3 = this.tab1$.asObservable();
        this.tab3Value = "";
        this.connectionKey$ = new BehaviorSubject("");
        this.connection = this.connectionKey$.asObservable();
        this.connectionValue = "";
        this.inboundKey$ = new BehaviorSubject("");
        this.inbound = this.inboundKey$.asObservable();
        this.inboundValue = "";
        this.outboundKey$ = new BehaviorSubject("");
        this.outbound = this.outboundKey$.asObservable();
        this.outboundValue = "";
        this.campaigns = [];
        this.campaign = "";
        this.didBackup = [];
        this.did = "";
        this.selectedDid = [];
        this.isChecked = false;
        this.isSelected = false;
        this.users = [];
        this.brandId = null;
        this.isCampaign = false;
        this.submitted = false;
        this.isAdmin = false;
        this.monthNameList = [];
        /* didList: any = []; */
        this.show = false;
        this.EXCEL_TYPE = 'application/csv';
        this.EXCEL_EXTENSION = '.csv';
        this.isEnable = false;
        this.Paste_number = true;
        this.selectedOption = '';
        this.sortField = '';
        this.sortOrder = 'asc';
        this.DidProviders = [
            { name: "thinQ", value: "ThinQ" },
            { name: "inteliQ", value: "InteliQ" },
            { name: "teleapi", value: "Teleapi" },
            { name: "Peerless", value: "Peerless" },
            { name: "coreTel", value: "CoreTel" }
        ];
        this.NumberType = [
            { type: "Local Number", value: "NN" },
            { type: "Toll-Free Number", value: "TF" }
        ];
        this.CurrentUConn = [];
        this.dIFlag = false;
        this.dIFBtn = "Import DID";
        this.stateList = [];
        this.campaignsAdmin = [];
        this.listedDid = [];
        this.connectionList = [];
        this.SIZE = 10;
        this.dismiss = false;
        this.increse_stop = false;
        this.btnType = '';
        this.subUsers = [];
        this.campDid = [];
        this.submittedMF = false;
        this.connectionDrop = false;
        this.connectiondata = [];
        this.roughData = [];
        this.findDID = [];
        this.notFindDID = [];
        this.campaignsUser = [];
        this.savedPage = 1;
        this.showDiv = {
            current: false,
            next: false
        };
        this.didtab = 'filters';
    }
    ngOnInit() {
        this.isEnable = true;
        this.state = 'closed';
        this.state1 = 'closed';
        this.selectThisMonth();
        this.slctDIDTotal = '';
        this.exportButton = 'Export All DID';
        this.iselectAll = false;
        this.selectedDIDCount = '';
        this.didDisInfo = '';
        let isLoggedIn = sessionStorage.getItem("isLoggedIn");
        let user = JSON.parse(isLoggedIn);
        this.username = user.username;
        this.user_id = user.iduser;
        this.account_id = user.idaccount;
        this.disButton = '';
        this.didCount = '';
        this.filterIconVal = "1";
        if (user.type == '1') {
            this.isAdmin = true;
            this.isClass = "col-md-4";
        }
        else {
            this.isAdmin = false;
            this.isClass = "col-md-8";
        }
        this.filterIconVal1 = "1";
        if (user.type == '1') {
            this.isAdmin = true;
            this.isClass = "col-md-4";
        }
        else {
            this.isAdmin = false;
            this.isClass = "col-md-8";
        }
        this.searchFilter = this.fb.group({
            numbers: new FormControl(''),
            selectAction: new FormControl(''),
            connVal: new FormControl(''),
            uploadfile: new FormControl('')
        });
        this.filterForm = this.fb.group({
            fromDate: new FormControl(''),
            toDate: new FormControl(''),
            selectedUser: new FormControl(''),
            didnumber: new FormControl('', [Validators.minLength(3), Validators.maxLength(10)]),
            didnpa: new FormControl('', [Validators.minLength(3)]),
            selectState: new FormControl(''),
            connectionKey: new FormControl(''),
            campaignKey: new FormControl(''),
            selectSMS: new FormControl(''),
            autoRenew: new FormControl('')
        }, {
            validator: Validators.compose([
                DidComponent_1.dateLessThan('fromDate', 'toDate', { 'fromDate': true })
            ])
        });
        this.uploadDid = this.fb.group({
            upload: new FormControl('', [Validators.required]),
            user: new FormControl('', [Validators.required]),
            campaign: new FormControl(''),
            connection: new FormControl(''),
            inbound: new FormControl(''),
            outbound: new FormControl(''),
            provider: new FormControl('', [Validators.required]),
            sms_provider: new FormControl(''),
            idtariff: new FormControl(''),
            numbertype: new FormControl('', [Validators.required]),
            description: new FormControl('')
        });
        this.data.getdid().subscribe((result) => {
            this.header = result[0].headers_details;
        });
        //To  get All DIDs
        this.getDIDs(this.filterForm.value);
        // this.campService.onGetCampaign().subscribe(response => {
        // 	if (response.status == 200) {
        // 		this.campaigns = response.data;
        // 	}
        // 	else {
        // 		this.errMessage = response.message;
        // 		setTimeout(() => {
        // 			this.errMessage = "";
        // 		}, 5000);
        // 	}
        // });
        this.optionVal();
        this.getConnection();
        this.userService.getUsers("main").subscribe(res => {
            if (res.status == 200) {
                this.users = res.data[0];
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = "Something went wrong with get Users!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
        this.data.getStates().subscribe(res => {
            this.stateList = res.data;
        });
        this.data.getDisconnectedDid().subscribe((res) => {
            this.getDID = res.data;
            if (this.getDID.length > 1) {
                this.isButton = '1';
            }
            else {
                this.isButton = '2';
            }
        });
        this.mess = '';
        this.ConnectionService.getConnection().subscribe(response => {
            if (response.status == 200) {
                if (response.data.length > 0) {
                    this.connectionList = response.data;
                }
            }
            else {
                this.errMessage = response.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = "Something went wrong with get Connection!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
        this.campService.GetCampaignsList().subscribe(result => {
            if (result.status == 200) {
                if (result.data.length > 0) {
                    this.campaignsUser = result.data;
                }
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
        this.campService.GetCampaignsListForAdmin("main").subscribe(result => {
            if (result.status == 200) {
                this.campaignsAdmin = result.data;
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
        this.getAllUsers();
        $('#didActionLog').on('show.bs.modal', function (event) {
            $(this).find('.nav button:first').tab('show');
        });
    }
    // To Get DIDs
    getDIDs(formData) {
        this.dids = [];
        this.data.onGetBuyDids(formData).subscribe((res) => {
            $('#basic-datatables').DataTable().clear();
            $('#basic-datatables').DataTable().destroy();
            this.SIZE = 10;
            if (res.status == 200) {
                this.dids = res.data;
                this.didBackup = this.dids;
                this.data.exportDID(this.filterForm.value).subscribe((ress) => {
                    if (ress.status == 200) {
                        this.allUserDIDLen = ress.data.length;
                        this.onTableSizeChange(10);
                        this.didCount = '(of ' + ress.data.length + ' total)';
                        $.getScript('./assets/managetable.js');
                    }
                });
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        }, (err) => {
            this.responseMessage = 'Something went wrong with get DIDs!';
            setTimeout(() => {
                this.responseMessage = '';
            }, 5000);
        });
    }
    changeState(val) {
        this.state == 'closed' ? (this.state = 'open') : (this.state = 'closed');
        val == '1' ? (this.filterIconVal = '2') : (this.filterIconVal = '1');
    }
    changeStatebulk(val) {
        this.state1 == 'closed' ? (this.state1 = 'open') : (this.state1 = 'closed');
        val == '1' ? (this.filterIconVal1 = '2') : (this.filterIconVal1 = '1');
    }
    /**
     * To load the selected customer's campaign
     */
    onCampaign(e) {
        this.camp = [];
        let iduser = e.target.value.split('-')[0];
        this.data.getCampaigns(iduser).subscribe(result => {
            if (result.status == 200) {
                if (result.data.length > 0) {
                    this.camp = result.data;
                }
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    /**
     * To get the selected customer's sms_provider
     */
    onSmsProvider(e) {
        this.camp = [];
        let iduser = e.target.value.split('-')[0];
        let idtariff = e.target.value.split('-')[2];
        let idtariffval = '';
        if (idtariff == '0') {
            idtariffval = 0;
        }
        else if (idtariff == '') {
            idtariffval = -1;
        }
        else {
            idtariffval = idtariff;
        }
        this.data.getSmsProvider(iduser).subscribe(result => {
            if (result.status == 200) {
                if (result.data.length > 0) {
                    this.sms_provider = result.data[0].sms_provider;
                    this.uploadDid.patchValue({
                        sms_provider: result.data[0].sms_provider,
                        idtariff: idtariffval
                    });
                }
            }
            else {
                this.uploadDid.patchValue({
                    sms_provider: '',
                    idtariff: idtariffval
                });
            }
        });
    }
    /**
     * To load the selected customer's connection
     */
    // onConnection(e:any ,type:any) {
    // 	this.CurrentUConn = [];
    // 	if(type == 'user' || type == 'subuser'){
    // 		this.Ciduser = e.target.value.split('-')[0];
    // 	}
    // 	if(type == 'reset'){
    // 		this.Ciduser = e.split('-')[0];
    // 	}
    // 	this.data.GetConnections(this.Ciduser).subscribe(result => {
    // 		if (result.status == 200) {
    // 			if (result.data.length > 0) {
    // 				this.CurrentUConn = result.data;
    // 				this.uploadDid.get("connection").setValue('');
    // 			}
    // 		}
    // 		else {
    // 			this.errMessage = result.message;
    // 			setTimeout(() => {
    // 				this.errMessage = "";
    // 			}, 5000);
    // 		}
    // 	});
    // }
    onConnection(e) {
        this.CurrentUConn = [];
        let iduser = e.target.value.split('-')[0];
        this.data.GetConnections(iduser).subscribe(result => {
            if (result.status == 200) {
                if (result.data.length > 0) {
                    this.CurrentUConn = result.data;
                }
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    multiSubmit() {
        if (!this.searchFilter.value.selectAction || this.searchFilter.value.selectAction == 'no') {
            this.errMessage = 'Please select Action Type';
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
            return true;
        }
        else {
            let payload = {
                num: this.searchFilter.value.numbers ? this.searchFilter.value.numbers.split(/[ ,\t\n]+/) : '',
                option: this.searchFilter.value.selectAction,
                file: this.file != undefined ? this.file : '',
                inboundValue: this.inboundValue,
                outboundValue: this.outboundValue,
                connectionValue: this.connectionValue
            };
            this.data.onGetMultiSearch(payload).subscribe(res => {
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                if (res.status == 200) {
                    this.dids = res.data;
                    this.roughData = res.roughDID;
                    this.findDID = res.findDID;
                    this.notFindDID = res.notFindDID;
                    this.onTableSizeChange(this.tableSize);
                    this.didCount = '(of ' + res.data.length + ' total)';
                    $.getScript('./assets/managetable.js');
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.clearFilter(1);
                    this.roughData = res.roughDID;
                    this.findDID = res.findDID;
                    this.notFindDID = res.notFindDID;
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.clearFilter(1);
                this.errMessage = "Something went wrong with Bulk Option or number formate is not correct!";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
    }
    getAllUsers() {
        this.userService.getAllUsers().subscribe(res => {
            if (res.status == 201) {
                this.subUsers = res.data[1];
                this.subUsers.forEach((ele) => {
                    ele.customer_data = JSON.parse(ele.customer_data);
                });
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    setConnectionFromBulk(e) {
        if (e.target.value == "set_connection") {
            this.connectionDrop = true;
            this.connectiondata = [];
            this.data.GetConnectionsByAccount(this.account_id).subscribe(result => {
                if (result.status == 200) {
                    if (result.data.length > 0) {
                        this.connectiondata = result.data;
                    }
                }
                else {
                    this.errMessage = result.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
        else {
            this.connectionDrop = false;
        }
    }
    getInOutKeyForSetConnection(e) {
        this.conn_key = e.target.value;
        this.disButton = '';
        this.data.onGetAllKeyByConnKey(this.conn_key).subscribe(res => {
            if (res.status == 200) {
                this.AllKeyData = res.data[0];
                this.inboundValue = this.AllKeyData.inbound_key;
                this.outboundValue = this.AllKeyData.outbound_key;
                this.connectionValue = this.AllKeyData.connection_key;
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
                this.disButton = '';
            }
        }, err => {
            this.responseMessage = "Something went wrong with get connection key for set connection!";
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
    }
    /**
     * To reset the import DID form
     */
    rSetForm() {
        this.submitted = false;
        this.dIFBtn = "Import DID";
        $('#exampleModal1').hide();
        this.closeModal.nativeElement.click();
    }
    reSet() {
        this.submitted = false;
        this.dIFBtn = "Import DID";
    }
    /**
     * Get All Connection List
     */
    getConnection() {
        this.data.listConnections().subscribe(res => {
            this.connectionLists = res.data;
            this.connectionKey$.next(this.connectionLists[0]);
            this.inboundKey$.next(this.connectionLists[1]);
            this.outboundKey$.next(this.connectionLists[2]);
        });
    }
    onSelectAll(e) {
        if (e.target.checked) {
            this.listedDid.forEach((ele) => {
                if (!ele.isChecked) {
                    ele.isChecked = true;
                    this.selectedDid.push(ele);
                }
                ;
            });
        }
        else {
            this.selectedDid = this.selectedDid.filter((ele) => !this.listedDid.includes(ele));
            this.listedDid.forEach((ele) => {
                if (ele.isChecked) {
                    ele.isChecked = false;
                }
                ;
            });
        }
        if (this.listedDid.length > 0 && this.listedDid.every((ele) => ele.isChecked)) {
            this.iselectAll = true;
        }
        else {
            this.iselectAll = false;
        }
        if (this.selectedDid.length > 0) {
            this.isSelected = true;
        }
        else {
            this.isSelected = false;
        }
        this.selectedDIDCount = this.selectedDid.filter((ele) => ele.isChecked).length;
    }
    onSelectDid(e, did, idx) {
        if (e.target.checked) {
            this.selectedDid.push(did);
        }
        else {
            this.selectedDid.forEach((value, index) => {
                if (value.iddid == did.iddid)
                    this.selectedDid.splice(index, 1);
            });
        }
        if (this.listedDid.length > 0 && this.listedDid.every((ele) => ele.isChecked)) {
            this.iselectAll = true;
        }
        else {
            this.iselectAll = false;
        }
        if (this.selectedDid.length > 0) {
            this.isSelected = true;
        }
        else {
            this.isSelected = false;
        }
        this.selectedDIDCount = this.selectedDid.length;
    }
    onConnectionKeyNew(e) {
        this.conn_key = e.target.value;
        this.disButton = '';
        this.data.onGetAllKeyByConnKey(this.conn_key).subscribe(res => {
            if (res.status == 200) {
                this.AllKeyData = res.data[0];
                this.inboundValue = this.AllKeyData.inbound_key;
                this.outboundValue = this.AllKeyData.outbound_key;
                this.connectionValue = this.AllKeyData.connection_key;
                this.disButton = 'true';
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
                this.disButton = '';
            }
        }, err => {
            this.responseMessage = "Something went wrong with Connection Key!";
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
    }
    getInOutKeys(e) {
        this.conn_key = e.target.value;
        this.disButton = '';
        this.data.onGetAllKeyByConnKey(this.conn_key).subscribe(res => {
            if (res.status == 200) {
                this.AllKeyData = res.data[0];
                this.inboundValue = this.AllKeyData.inbound_key;
                this.outboundValue = this.AllKeyData.outbound_key;
                this.connectionValue = this.AllKeyData.connection_key;
                this.uploadDid.patchValue({
                    inbound: this.inboundValue,
                    outbound: this.outboundValue,
                });
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
                this.disButton = '';
            }
        }, err => {
            this.responseMessage = "Something went wrong with Inbound and Outbound Key!";
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
    }
    onConnectionKey(e) {
        this.inboundValue = "";
        this.outboundValue = "";
        this.connectionValue = "";
        this.connectionValue = e.target.value;
    }
    onInboundKey(e) {
        this.inboundValue = "";
        this.outboundValue = "";
        this.connectionValue = "";
        this.inboundValue = e.target.value;
    }
    onOutboundKey(e) {
        this.inboundValue = "";
        this.outboundValue = "";
        this.connectionValue = "";
        this.outboundValue = e.target.value;
    }
    onSelectCampagin(e) {
        this.inboundValue = "";
        this.outboundValue = "";
        this.connectionValue = "";
        this.iduser = this.iduser;
        this.campaign = e.target.value;
        this.data.getCampaignDIDCount(this.campaign, this.iduser).subscribe((camp) => {
            if (camp.status == 200) {
                this.isEnable = false;
                if (camp.data[0].did_count >= camp.data[0].did_limit) {
                    this.isEnable = true;
                    this.mess = `You can enable only ${camp.data[0].did_limit} DID's in this Campaign.`;
                }
                else if (camp.data[0].did_limit <= 0) {
                    this.isEnable = true;
                    this.mess = 'You can not Enable any DID with this campaign.';
                }
                else {
                    this.isEnable = false;
                    this.mess = '';
                }
                if (this.campaign == this.OLDcampid) {
                    this.btnTypeHide = false;
                    this.isEnable = true;
                }
                else {
                    this.btnTypeHide = true;
                    this.isEnable = false;
                }
            }
            else {
                this.isEnable = false;
                this.mess = '';
            }
        });
        let campInfo = this.campaigns.find(el => el.campaign_key === this.campaign);
        if (campInfo.campaign_key == this.OLDcampid) {
            if (this.type == 1)
                this.tryingStep = '1';
            if (this.type == 2)
                this.tryingStep = '2';
            if (this.type == 3)
                this.tryingStep = '3';
            /* if(campInfo.upstreamCnpId.toLowerCase() == "sinch"){
                if(this.type == 1)
                    this.tryingStep = '1'
                if(this.type == 2)
                    this.tryingStep = '2'
                if(this.type == 3)
                    this.tryingStep = '3'
            }
            else{
                if(this.type == 1)
                    this.tryingStep = '1'
                if(this.type == 2)
                    this.tryingStep = '2'
                if(this.type == 3)
                    this.tryingStep = '3'
            } */
        }
        else {
            this.tryingStep = '1';
            /* if(campInfo.upstreamCnpId.toLowerCase() == "sinch"){
                this.tryingStep = '1'
            }
            else{
                this.tryingStep = '1'
            } */
        }
    }
    getCampRegDID() {
        this.campDid = [];
        this.data.getCampaignDID(this.campaign, this.iduser).subscribe((res) => {
            if (res.status == 200) {
                this.campDid = res.data;
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    onUpdateConnection() {
        let updateDID = {};
        updateDID = {
            iddid: this.iddid, connection_key: this.connectionValue, did: this.did,
            inboundKey: this.inboundValue, outboundKey: this.outboundValue, campaign: this.campaign
        };
        this.data.updateDID(updateDID).subscribe(res => {
            if (res.status == 201) {
                this.iselectAll = false;
                this.selectedDIDCount = '';
                this.selectedDid = [];
                this.responseMessage = res.message;
                window.location.reload();
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, error => {
            this.responseMessage = "Something went wrong with update connection!";
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
    }
    enableDIDSMS() {
        let updateDID = {};
        updateDID = {
            iddid: this.iddid, DID: this.did, CampaignId: this.campaign, iduser: this.iduser
        };
        // let disableDID: any = {};
        // disableDID ={
        // 	iddid: this.iddid, DID: this.did, CampaignId: this.OLDcampid, iduser: this.iduser
        // };
        if (this.OLDcampid !== '') {
            if (confirm("This DID will be Disable from previous campaign after that it will be Enable with new campaign!")) {
                if (confirm("Are you sure you want to Disable SMS service from old Campaign and Enable with New Campaign!")) {
                    this.data.disableSMS(this.did, this.iduser).subscribe(disres => {
                        if (disres.status == 200 || disres.status == 201 || disres.status == 202) {
                            this.enableSMS(updateDID);
                        }
                        else {
                            this.errMessage = disres.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 5000);
                        }
                    });
                }
            }
        }
        else {
            if (confirm("Are you sure you want to Enable SMS service from this Campaign!")) {
                this.enableSMS(updateDID);
            }
        }
    }
    enableSMS(updateDID) {
        this.data.enableSMS(updateDID).subscribe(res => {
            this.iselectAll = false;
            this.selectedDIDCount = '';
            this.selectedDid = [];
            if (res.status == 200) {
                this.getDIDs(this.filterForm.value);
                this.responseMessage = res.message;
                //window.location.reload();
                this.btnType = 'disable';
                this.isEnable = true;
                this.btnTypeHide = false;
                this.OLDcampid = updateDID.CampaignId;
                setTimeout(() => {
                    this.responseMessage = "";
                    document.getElementById("campaignModalClose").click();
                }, 5000);
            }
            else {
                //this.btnType='enable';
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, error => {
            //this.btnType='enable';
            this.errMessage = "Something went wrong with Enable SMS!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    reEnableDIDSMS() {
        let updateDID = {};
        updateDID = {
            iddid: this.iddid, DID: this.did, CampaignId: this.campaign, iduser: this.iduser, idaccount: this.idaccount, sinchStatus: this.sinchStatus
        };
        this.reProvisioningSMS(updateDID);
    }
    reProvisioningSMS(updateDID) {
        this.data.reProvisioningSMS(updateDID).subscribe(res => {
            this.iselectAll = false;
            this.selectedDIDCount = '';
            this.selectedDid = [];
            if (res.status == 200) {
                this.getDIDs(this.filterForm.value);
                this.responseMessage = res.message;
                //window.location.reload();
                this.btnType = 'disable';
                this.isEnable = true;
                this.btnTypeHide = false;
                this.OLDcampid = updateDID.CampaignId;
                setTimeout(() => {
                    this.responseMessage = "";
                    document.getElementById("campaignModalClose").click();
                }, 5000);
            }
            else {
                //this.btnType='enable';
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, error => {
            //this.btnType='enable';
            this.errMessage = "Something went wrong with Re-Provisioning!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    disableDIDSMS() {
        if (this.did && this.iduser) {
            if (confirm("Are you sure you want to Disable SMS service from this Campaign!")) {
                this.data.disableSMS(this.did, this.iduser).subscribe(disres => {
                    if (disres.status == 200 || disres.status == 201 || disres.status == 202) {
                        this.getDIDs(this.filterForm.value);
                        this.responseMessage = disres.message;
                        this.campaign = "";
                        this.isEnable = true;
                        setTimeout(() => {
                            this.responseMessage = "";
                            document.getElementById("campaignModalClose").click();
                        }, 5000);
                    }
                    else {
                        this.btnType = 'disable';
                        this.errMessage = disres.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                }, error => {
                    this.btnType = 'disable';
                    this.errMessage = "Something went wrong with Disable SMS service!";
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                });
            }
        }
        else {
            this.errMessage = "Information not collected!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        }
    }
    onUpdateSelectedDids() {
        let updateDID = [];
        this.selectedDid.forEach((el) => {
            updateDID.push({
                iddid: el.iddid, connection_key: this.connectionValue, did: el.did,
                inboundKey: this.inboundValue, outboundKey: this.outboundValue, campaign: this.campaign
            });
        });
        this.data.updateSelectedDids(updateDID).subscribe(res => {
            if (res.status == 201) {
                this.iselectAll = false;
                this.selectedDIDCount = '';
                this.selectedDid = [];
                this.responseMessage = res.message;
                window.location.reload();
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, error => {
            this.responseMessage = "Something went wrong with update selected DIDs!";
            setTimeout(() => {
                this.responseMessage = "";
            }, 5000);
        });
    }
    disconnectDids() {
        if (confirm("Please Confirm You Want To Disconnect Selected DID's")) {
            if (confirm("Are you sure you want to Disconnect Selected DID's")) {
                this.data.disconnectSelectedDids(this.selectedDid).subscribe(res => {
                    $('#basic-datatables').DataTable().clear();
                    $('#basic-datatables').DataTable().destroy();
                    this.iselectAll = false;
                    this.selectedDid = [];
                    this.selectedDIDCount = '';
                    if (res.status == 201) {
                        this.selectedDid = [];
                        this.selectedDIDCount = '';
                        this.didDisInfo = res.disdata;
                        this.didDisInfolen = res.disdata.length;
                        this.didNotDisInfo = res.notdisDID;
                        this.didNotDisInfolen = res.notdisDID.length;
                        this.slctDIDTotal = this.didDisInfolen + this.didNotDisInfolen;
                        this.responseDIDMessage = true;
                        setTimeout(() => {
                            this.responseDIDMessage = false;
                        }, 30000);
                        this.responseMessage = res.message;
                        setTimeout(() => {
                            this.responseMessage = "";
                        }, 5000);
                    }
                    else {
                        this.errMessage = res.message;
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    }
                    $('#basic-datatables').DataTable().clear();
                    $('#basic-datatables').DataTable().destroy();
                    this.data.onGetBuyDids(this.filterForm.value).subscribe(res => {
                        this.didCount = '';
                        this.iselectAll = false;
                        this.selectedDid = [];
                        this.selectedDIDCount = '';
                        if (res.status == 200) {
                            //this.exportButton='Export Filtered DID';
                            this.dids = res.data;
                            $.getScript('./assets/managetable.js');
                            this.data.exportDID(this.filterForm.value).subscribe(res => {
                                if (res.status == 200) {
                                    this.didCount = '(of ' + res.data.length + ' total)';
                                }
                            });
                        }
                        else {
                            this.errMessage = res.message;
                            setTimeout(() => {
                                this.errMessage = "";
                            }, 5000);
                        }
                    }, err => {
                        this.errMessage = "Something went wrong with get DIDs!";
                        setTimeout(() => {
                            this.errMessage = "";
                        }, 5000);
                    });
                }, err => {
                    this.responseMessage = "Something went wrong with Disconnect Selected DIDs!";
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                });
                ;
            }
            else {
                return;
            }
        }
        else {
            return;
        }
    }
    disconnectDid(did, iduser) {
        if (confirm("Please Confirm You Want To Disconnect Selected Dids")) {
            this.data.onDisconnectDid(did, iduser).subscribe(res => {
                this.iselectAll = false;
                this.selectedDid = [];
                this.selectedDIDCount = '';
                if (res.status == 201) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.ngOnInit();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.responseMessage = "Something went wrong with Disconnect DID!";
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
        else {
            return;
        }
    }
    onSMSStatus(iddid, type, sinchStatus) {
        this.type = type;
        //this.tryingStep = this.type == 1 ? '1' : '2';
        this.sinchStatus = sinchStatus;
        this.did = "";
        this.iddid = iddid;
        this.campaign = "";
        let did = this.dids.find(el => el.iddid == iddid);
        this.campaign = (did.camp_registry !== '' && did.camp_registry !== null && did.camp_registry !== undefined && did.camp_registry !== 'null' && did.camp_registry !== 'undefined') ? did.camp_registry : '';
        this.did = did.did;
        this.iduser = did.iduser;
        this.idaccount = did.account_id;
        this.OLDcampid = this.campaign;
        if (this.OLDcampid !== '') {
            this.btnType = 'disable';
            this.isEnable = true;
        }
        else {
            this.btnType = 'enable';
            this.isEnable = true;
        }
        this.data.getCampaigns(this.iduser).subscribe(result => {
            if (result.status == 200) {
                if (result.data.length > 0) {
                    this.campaigns = result.data;
                    let campInfo = this.campaigns.find(el => el.campaign_key === this.campaign);
                    if (this.type == 1)
                        this.tryingStep = '1';
                    if (this.type == 2)
                        this.tryingStep = '2';
                    if (this.type == 3)
                        this.tryingStep = '3';
                    /* if(campInfo && campInfo.upstreamCnpId.toLowerCase() == "sinch"){
                        if(this.type == 1)
                            this.tryingStep = '1'
                        if(this.type == 2)
                            this.tryingStep = '2'
                        if(this.type == 3)
                            this.tryingStep = '3'
                    }
                    else{
                        if(this.type == 1)
                            this.tryingStep = '1'
                        if(this.type == 2)
                            this.tryingStep = '2'
                        if(this.type == 3)
                            this.tryingStep = '3'
                    } */
                }
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    tabSetting(data, tabs) {
        if (data != "data") {
            this.did = "";
            this.connectionValue = "";
            this.inboundValue = "";
            this.outboundValue = "";
            this.iddid = data.iddid;
            let did = this.dids.find(el => el.iddid == data.iddid);
            this.did = did.did;
            this.connectionValue = did.connection_key;
            this.inboundValue = did.inbound_key;
            this.outboundValue = did.outbound_key;
            if ((this.connectionValue) && (this.inboundValue) && (this.outboundValue)) {
                this.disButton = 'true';
            }
            else {
                this.disButton = '';
            }
        }
        switch (tabs) {
            case 1: {
                this.tab1Value = "active";
                this.tab2Value = "";
                this.tab3Value = "";
                break;
            }
            case 2: {
                this.tab1Value = "";
                this.tab2Value = "active";
                this.tab3Value = "";
                break;
            }
            case 3: {
                this.tab1Value = "";
                this.tab2Value = "";
                this.tab3Value = "active";
                break;
            }
        }
    }
    onTableSize(e) {
        if (e) {
            this.tableSizeN = e;
        }
        else {
            this.tableSizeN = this.tableSize;
        }
    }
    minus() {
        this.tableSize = Math.floor(Math.floor(this.tableSize) - Math.floor(1));
        this.onTableSizeChange(this.tableSize);
        if (this.tableSize == 1) {
            this.dismiss = true;
        }
        else {
            this.dismiss = false;
        }
        if (this.tableSize < 1000) {
            this.increse_stop = false;
        }
        else {
            this.increse_stop = true;
        }
    }
    plus() {
        this.tableSize = Math.floor(Math.floor(this.tableSize) + Math.floor(1));
        this.onTableSizeChange(this.tableSize);
        if (this.tableSize > 1) {
            this.dismiss = false;
            if (this.tableSize > 999) {
                this.increse_stop = true;
            }
            else {
                this.increse_stop = false;
            }
        }
        else {
            this.dismiss = true;
        }
    }
    onTableSizeChange(event) {
        if (event[1] !== ":") {
            this.tableSize = event;
            if (this.tableSize > 0) {
                this.tableSize = this.tableSize;
            }
            else {
                if (this.tableSizeN) {
                    this.tableSize = this.tableSizeN;
                }
                else {
                    this.tableSize = this.SIZE;
                }
            }
        }
        else {
            this.tableSize = this.SIZE;
            this.dismiss = false;
        }
        // this.selectedDIDCount = 0;
        // this.selectedDid.splice(0);
        // this.iselectAll = false;
        this.page;
        this.dids;
        this.listedDid = [];
        if (this.tableSize == 1000) {
            this.listedDid = this.dids;
        }
        else {
            let c = this.tableSize * this.page == 10 ? 0 : this.tableSize * (this.page - 1);
            let C = Math.floor(Math.floor(c) + Math.floor(this.tableSize));
            for (let i = 0; i < this.dids.length; i++) {
                if (i >= c && i < C) {
                    this.listedDid.push(this.dids[i]);
                }
            }
        }
        let count;
        if (this.dids.length === 0) {
            count = 0;
        }
        else if (this.page <= 1) {
            count = 1;
        }
        else {
            count = Math.min(((this.page - 1) * this.tableSize) + 1, this.dids.length);
        }
        let tblEntry = 0;
        if (this.tableSize * this.page < this.dids.length) {
            tblEntry = this.tableSize * this.page;
        }
        else {
            tblEntry = this.dids.length;
        }
        this.shwoingEntry = count;
        this.sInfo = "Showing " + count + " to " + tblEntry + " of " + this.dids.length + " entries (of " + this.allUserDIDLen + " total)";
        // this.listedDid.forEach((ele: any) => {
        // 	ele.isChecked = false;
        // });
    }
    onTableDataChange(event) {
        this.page = event;
        this.savedPage = event;
        this.dids;
        this.onTableSizeChange(this.tableSize);
        this.iselectAll = this.listedDid.length > 0 && this.listedDid.every((ele) => ele.isChecked);
    }
    reload() {
        this.tab1Value = "";
        this.tab2Value = "";
        this.tab3Value = "";
    }
    uploadListener($event) { }
    onFilePicked(event) {
        const file = event.target.files[0];
        this.file = file;
        const reader = new FileReader();
        reader.readAsDataURL(file);
    }
    onUpload() {
        this.submitted = false;
        if (this.uploadDid.invalid) {
            // alert("Mandatory fields are required!");
            this.submitted = true;
            return;
        }
        else {
            this.dIFlag = true;
            this.dIFBtn = "Uploading...";
            this.data.uploadDid(this.uploadDid.value, this.file).subscribe(response => {
                this.dIFlag = false;
                if (response.status == 201) {
                    this.uploadDid.reset();
                    this.closeModal.nativeElement.click();
                    this.ngOnInit();
                    this.dIFBtn = "Imported";
                    this.upload = response.data;
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.dIFBtn = "Import DID";
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.dIFBtn = "Import DID";
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.dIFlag = false;
                this.dIFBtn = "Import DID";
                this.errMessage = "Something went wrong with upload DIDs!";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
    }
    selectedFromDate(e) {
        this.submitted = true;
        if (e.target.value) {
            this.filterForm.get("toDate").setValidators(Validators.required);
            this.filterForm.get("toDate").updateValueAndValidity();
        }
    }
    selectedToDate(e) {
        this.submitted = true;
        if (e.target.value) {
            this.filterForm.get("fromDate").setValidators(Validators.required);
            this.filterForm.get("fromDate").updateValueAndValidity();
        }
    }
    filterByUser(e) {
        this.filterForm.patchValue({
            selectedUser: e.target.value
        });
    }
    filterByConnection(e) {
        this.filterForm.patchValue({
            connectionKey: e.target.value
        });
    }
    filterByCampaign(e) {
        this.filterForm.patchValue({
            campaignKey: e.target.value
        });
    }
    filterSubmit() {
        this.submitted = true;
        if (this.filterForm.invalid) {
            return false;
        }
        else {
            this.data.onGetBuyDids(this.filterForm.value).subscribe(res => {
                this.didCount = '';
                this.iselectAll = false;
                this.selectedDid = [];
                this.selectedDIDCount = '';
                $('#basic-datatables').DataTable().clear();
                $('#basic-datatables').DataTable().destroy();
                if (res.status == 200) {
                    this.exportButton = 'Export Filtered DID';
                    this.dids = res.data;
                    this.data.exportDID(this.filterForm.value).subscribe(res => {
                        if (res.status == 200) {
                            this.page = 1;
                            this.allUserDIDLen = res.data.length;
                            this.onTableSizeChange(this.tableSize);
                            this.didCount = '(of ' + res.data.length + ' total)';
                            $.getScript('./assets/managetable.js');
                        }
                    });
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.errMessage = "Something went wrong with DID Filter!";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            });
        }
        this.show = true;
    }
    autoRenew(iddid, did) {
        const variVal = document.getElementById("isEnable-" + iddid);
        if (variVal.innerHTML == 'Enabled') {
            this.getVal = "Disabled";
        }
        else {
            this.getVal = "Enabled";
        }
        var data = { iddid: iddid, isEnable: this.getVal, did: did };
        this.data.enableDisable(data).subscribe(response => {
            if (response.status == 201) {
                if (variVal.innerHTML == "Enabled") {
                    variVal.innerHTML = "Disabled";
                    variVal.className = "btn-red btn-xs btn-style";
                    this.errMessage = '(' + did + ') ' + response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                        this.getDIDs(this.filterForm.value);
                    }, 5000);
                }
                else {
                    variVal.innerHTML = "Enabled";
                    variVal.className = "btn-green btn-xs btn-style";
                    this.responseMessage = '(' + did + ') ' + response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                        this.getDIDs(this.filterForm.value);
                    }, 5000);
                }
            }
            else {
                this.errMessage = response.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    clearFilter(e) {
        this.page = this.savedPage;
        this.roughData = [];
        this.findDID = [];
        this.notFindDID = [];
        this.connectionDrop = false;
        this.iselectAll = false;
        this.selectedDid = [];
        this.selectedDIDCount = '';
        this.resetDt();
        this.filterForm.reset();
        // if (e == 1 || e == 2)
        if (e == 1 || e == 2 || e == 4)
            this.ngOnInit();
    }
    optionVal() {
        this.searchFilter.patchValue({
            selectAction: 'no',
            connVal: 'no'
        });
    }
    resetDt() {
        this.iselectAll = false;
        this.selectedDid = [];
        this.selectedDIDCount = '';
        this.optionVal();
        // $('#basic-datatables').DataTable().clear().destroy();
    }
    downloadCSVFile() {
        this.iselectAll = false;
        this.selectedDid.forEach((ele) => {
            ele.isChecked = false;
        });
        this.selectedDid = [];
        this.selectedDIDCount = '';
        this.data.exportDID(this.filterForm.value).subscribe(res => {
            if (res.status == 200) {
                let manageDID = res.data;
                if (manageDID.length > 0) {
                    const worksheet = XLSX.utils.json_to_sheet(manageDID);
                    const workbook = { Sheets: { 'did': worksheet }, SheetNames: ['did'] };
                    const excelBuffer = XLSX.write(workbook, { bookType: 'csv', type: 'array' });
                    this.saveAsExcelFile(excelBuffer, "did_" + res.username + "_");
                }
                else {
                    this.errMessage = "DID Not Available";
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }
        });
    }
    saveAsExcelFile(buffer, fileName) {
        const data = new Blob([buffer], {
            type: this.EXCEL_TYPE
        });
        //let dateObj = new Date();
        let date = new Date().toLocaleDateString('en-US').replace('_', '/');
        saveAs(data, fileName + date + this.EXCEL_EXTENSION);
    }
    startDate() {
        let now = new Date();
        let year = "" + now.getFullYear();
        let month = "" + (now.getMonth() + 1);
        if (month.length == 1) {
            month = "0" + month;
        }
        let day = "" + now.getDate();
        if (day.length == 1) {
            day = "0" + day;
        }
        let hour = "" + now.getHours();
        if (hour.length == 1) {
            hour = "0" + hour;
        }
        let minute = "" + now.getMinutes();
        if (minute.length == 1) {
            minute = "0" + minute;
        }
        let second = "" + now.getSeconds();
        if (second.length == 1) {
            second = "0" + second;
        }
        return year + '-' + month + "-" + "01";
    }
    current_datetime() {
        let now = new Date();
        let year = "" + now.getFullYear();
        let month = "" + (now.getMonth() + 1);
        if (month.length == 1) {
            month = "0" + month;
        }
        let day = "" + now.getDate();
        if (day.length == 1) {
            day = "0" + day;
        }
        let hour = "" + now.getHours();
        if (hour.length == 1) {
            hour = "0" + hour;
        }
        let minute = "" + now.getMinutes();
        if (minute.length == 1) {
            minute = "0" + minute;
        }
        let second = "" + now.getSeconds();
        if (second.length == 1) {
            second = "0" + second;
        }
        return year + '-' + month + "-" + day;
    }
    monthsList() {
        this.monthNameList = [
            { name: "Jan", value: "1" },
            { name: "Feb", value: "2" },
            { name: "Mar", value: "3" },
            { name: "Apr", value: "4" },
            { name: "May", value: "5" },
            { name: "Jun", value: "6" },
            { name: "Jul", value: "7" },
            { name: "Aug", value: "8" },
            { name: "Sep", value: "9" },
            { name: "Oct", value: "10" },
            { name: "Nov", value: "11" },
            { name: "Dec", value: "12" }
        ];
    }
    selectThisMonth() {
        let now = new Date();
        let year = now.getFullYear();
        let month = now.getMonth() + 1;
        let day = new Date(year, month, 0).getDate();
        this.toDate = year + '-' + month + '-' + day;
    }
    static dateLessThan(fromDate, toDate, validatorField) {
        return (c) => {
            const date1 = c.get(fromDate).value;
            const date2 = c.get(toDate).value;
            if ((date1 !== null && date2 !== null) && date1 > date2) {
                return validatorField;
            }
            return null;
        };
    }
    reset() {
        this.connectionValue = '';
    }
    // checkbox1
    displayfield(evt) {
        if (this.Paste_number) {
            this.Paste_number = false;
            this.selectedOption = '';
        }
        else {
            this.Paste_number = true;
            this.selectedOption = '';
            this.searchFilter.get('numbers').setValue('');
        }
        this.roughData = [];
        this.findDID = [];
        this.notFindDID = [];
        this.file = '';
        this.searchFilter.patchValue({
            numbers: '',
            uploadfile: ''
        });
    }
    onClick(check) {
        if (check == 1) {
            this.didtab = 'filter';
        }
        else if (check == 2) {
            this.didtab = 'bulk';
        }
    }
    onSwitch(check) {
        switch (check) {
            case 1:
                return 'filter';
            case 2:
                return 'bulk';
        }
    }
    onSearch(data) {
        if (data) {
            let searchText = '';
            searchText = data.toLowerCase();
            this.dids = this.didBackup.filter(it => {
                return Object.keys(it).some(key => {
                    if (data.includes('/') && (key === 'subscription_end_date' || key === 'created_at')) {
                        it[key] = formatDate(it[key], 'MM/dd/yyyy', 'en-US');
                        return String(it[key]).toLowerCase().includes(searchText);
                    }
                    else {
                        return String(it[key]).toLowerCase().includes(searchText);
                    }
                });
            });
            this.page = 1;
            this.onTableSizeChange(this.tableSize);
        }
        else {
            this.dids = this.didBackup;
            this.page = this.savedPage;
            this.onTableSizeChange(this.tableSize);
        }
    }
    sort_did(data) {
        const getField = (data) => {
            switch (data) {
                case 'DID':
                    return 'did';
                case 'NPA':
                    return 'npa';
                case 'NXX':
                    return 'nxx';
                case 'State':
                    return 'state';
                case 'Rate Center':
                    return 'ratecenter';
                case 'Connection':
                    return 'connectionName';
                case 'Start Subscription':
                    return 'created_at';
                case 'End Subscription':
                    return 'subscription_end_date';
                case 'Auto Renewal':
                    return 'sub_auto_renew';
                case 'Disconnect Days':
                    return 'did_disconnect_days';
                default:
                    return '';
            }
        };
        const field = getField(data);
        if (field) {
            this.sortOrder = this.sortField === field ? (this.sortOrder === 'asc' ? 'desc' : 'asc') : 'asc';
            let startIndex = (this.page - 1) * this.tableSize;
            let endIndex = startIndex + this.tableSize;
            const entriesToSort = this.dids.slice(startIndex, endIndex);
            entriesToSort.sort((a, b) => {
                const comparison = this.sortOrder === 'asc' ? 1 : -1;
                return a[field] < b[field] ? -comparison : a[field] > b[field] ? comparison : 0;
            });
            for (let i = startIndex, j = 0; i < endIndex && j < entriesToSort.length; i++, j++) {
                this.dids[i] = entriesToSort[j];
            }
            this.sortField = field;
        }
    }
};
__decorate([
    ViewChild('closeModal')
], DidComponent.prototype, "closeModal", void 0);
DidComponent = DidComponent_1 = __decorate([
    Component({
        selector: 'app-did',
        templateUrl: './did.component.html',
        styleUrls: ['./did.component.css'],
        animations: [
            trigger('widthGrow', [
                state('closed', style({
                    border: "0px",
                    height: "0px",
                    margin: "0px 0px 20px 0px",
                })),
                state('open', style({
                    margin: "0px 0px 20px 0px",
                })),
                transition('* => *', animate(500)),
            ]),
            trigger('widthGrow1', [
                state('closed', style({
                    border: "0px",
                    height: "0px",
                    // margin: "0px 0px 20px 0px",
                })),
                state('open', style({
                // margin: "0px 0px 20px 0px",
                })),
                transition('* => *', animate(500)),
            ]),
        ],
    })
], DidComponent);
export { DidComponent };
//# sourceMappingURL=did.component.js.map