import { __decorate } from "tslib";
import { Component } from '@angular/core';
let DisDidRestoreComponent = class DisDidRestoreComponent {
    constructor(data) {
        this.data = data;
        this.selectedDid = [];
        this.dids = [];
        this.isSelected = false;
        this.isChecked = false;
        this.responseMessage = "";
        this.errMessage = "";
        // page: number = 1;
        this.count = 0;
        this.tableSize = 10;
        this.tableSizes = [10, 20, 50, 100, 1000];
        this.iselectAll = false;
        this.listedDid = [];
        this.didCount = [];
        this.SIZE = 10;
        // tableSizeN: number;
        this.dismiss = false;
        this.increse_stop = false;
    }
    ngOnInit() {
        this.selectedDIDCount = '';
        this.didCount = '';
        this.data.getdid().subscribe((result) => {
            this.header = result[0].headers_details;
        });
        this.data.getDisconnectedDid().subscribe(res => {
            $('#basic-datatables').DataTable().clear();
            $('#basic-datatables').DataTable().destroy();
            if (res.status == 200) {
                this.getDID = res.data;
                // this.onTableSizeChange(10);
                this.didCount = '(of ' + res.data.length + ' total)';
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onSelectAll(e) {
        if (e.target.checked) {
            this.selectedDid = [];
            this.getDID.forEach((ele) => {
                ele.isChecked = true;
                this.selectedDid.push(ele);
            });
        }
        else {
            this.iselectAll = false;
            this.selectedDid = [];
            this.getDID.forEach((ele) => {
                ele.isChecked = false;
            });
        }
        if (this.selectedDid.length == this.getDID.length) {
            this.iselectAll = true;
        }
        else {
            this.iselectAll = false;
        }
        this.selectedDIDCount = this.selectedDid.length;
    }
    onSelectDid(e, did, idx) {
        if (e.target.checked) {
            this.selectedDid.push(did);
        }
        else {
            this.selectedDid.forEach((value, index) => {
                if (value.iddid == did.iddid)
                    this.selectedDid.splice(index, 1);
            });
        }
        if (this.selectedDid.length == this.getDID.length) {
            this.iselectAll = true;
        }
        else {
            this.iselectAll = false;
        }
        if (this.selectedDid.length > 0) {
            this.isSelected = true;
        }
        else {
            this.isSelected = false;
        }
        this.selectedDIDCount = this.selectedDid.length;
    }
    restoreDisconnectDID() {
        if (confirm("Please Confirm You Want To Restore Selected DIDs")) {
            this.data.restoreDisconnectDid(this.selectedDid).subscribe(res => {
                this.selectedDid = [];
                this.selectedDIDCount = '';
                if (res.status == 200) {
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                    this.ngOnInit();
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            }, err => {
                this.selectedDIDCount = '';
                this.responseMessage = err.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            });
        }
        else {
            return;
        }
        this.selectedDid = [];
        this.getDID.forEach((ele) => {
            ele.isChecked = false;
        });
    }
};
DisDidRestoreComponent = __decorate([
    Component({
        selector: 'app-dis-did-restore',
        templateUrl: './dis-did-restore.component.html',
        styleUrls: ['./dis-did-restore.component.css'],
        // encapsulation: ViewEncapsulation.None,
    })
], DisDidRestoreComponent);
export { DisDidRestoreComponent };
//# sourceMappingURL=dis-did-restore.component.js.map