import { createFeatureSelector, createSelector } from '@ngrx/store';
import { SET, REMOVE, RESET, ADD, REMOVE_ITEMS } from './inbound.action';
const initialState = {
    cart: []
};
export function inboundReducer(state = initialState, action) {
    switch (action.type) {
        case SET:
            return Object.assign(Object.assign({}, state), { cart: action.payload });
        case ADD:
            let carts = action.payload;
            // let data1 = state.cart.filter(item1 => {
            //     if(item1.did != item.phone_number){
            //       return item
            //     }
            // });
            // let newItem: any;
            // carts.forEach(item => {
            //      newItem = {idaccount: 0, id_cart: 0, did: item.phone_number, provider: '', disable: ''};
            // });
            return Object.assign(Object.assign({}, state), { cart: [...state.cart, ...carts] });
        // case ADDALL: 
        //     // let newItems: any = [];
        //     let items: any = action.payload;
        //     // items.forEach(element => {
        //     //   newItems.push({idaccount: 0, id_cart: 0, did: element.phone_number, provider: '', disable: ''})
        //     // });
        //     return {
        //       ...state,
        //       cart: [...state.cart, ...items]
        //     };
        case REMOVE:
            let data = state.cart.filter((item, idx) => {
                if (item.did != action.payload.did) {
                    return item;
                }
            });
            return Object.assign(Object.assign({}, state), { cart: data });
        case REMOVE_ITEMS:
            let items = state.cart.filter(item => {
                if (item.did != action.payload.did) {
                    return item;
                }
            });
            return Object.assign(Object.assign({}, state), { cart: items });
        case RESET:
            return Object.assign(Object.assign({}, state), { cart: action.payload });
        default:
            return Object.assign(Object.assign({}, state), { cart: state });
    }
}
export const getInboundState = createFeatureSelector('inbound');
export const getCartItems = createSelector(getInboundState, (state) => state.cart);
//# sourceMappingURL=inbound.reducer.js.map