import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { ipForm } from '../inbound.class';
let IpaddressComponent = class IpaddressComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        // defaultSelect : any = 1;
        this.show1 = false;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
    }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new ipForm(res);
                this.keyfield = res.id;
                this.ipForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new ipForm(null);
                this.keyfield = -1;
                this.ipForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.getipaddress().subscribe((result) => {
            this.ipaddress = result[0].headers_details;
            this.iplist = result[0].ip_details;
            this.ipfield = result[1];
            console.log(result);
        });
        // $(document).ready(function() {
        // 		$('#basic-datatables').DataTable({
        // 		});
        // 	});
    }
    toggle() {
        this.show = !this.show;
        // CHANGE THE NAME OF THE BUTTON.
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
    // @to edit the record
    editRow(rowdata) {
        this.show = true;
        this.Edit(rowdata);
    }
    get f() { return this.ipForm.controls; }
    ;
    // @to save/update form data
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.ipForm.invalid) {
            return false;
        }
        else {
            let input_data = [this.cdata];
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.ipForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    // Dynamic Form
    saveForm(data) {
        console.log(data, "data");
    }
    onTableSizeChange(event) {
        this.tableSize = event.target.value;
        this.page = 1;
    }
    onTableDataChange(event) {
        this.page = event;
    }
    click() {
        this.show1 = !this.show1;
    }
};
IpaddressComponent = __decorate([
    Component({
        selector: 'app-ipaddress',
        templateUrl: './ipaddress.component.html',
        styleUrls: ['./ipaddress.component.css']
    })
], IpaddressComponent);
export { IpaddressComponent };
//# sourceMappingURL=ipaddress.component.js.map