import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { KycComponent } from './kyc/kyc.component';
import { KycPdfComponent } from './kyc-pdf/kyc-pdf.component';
const routes = [
    {
        path: 'kyc',
        component: KycComponent,
        data: {
            title: 'kyc',
            urls: [
                {
                    title: ' kyc',
                },
                {
                    title: 'kyc'
                }
            ]
        }
    },
    {
        path: 'kyc-details',
        component: KycPdfComponent,
        data: {
            title: 'kyc-details',
            urls: [
                {
                    title: 'kyc-details',
                },
                {
                    title: 'kyc-details'
                }
            ]
        }
    },
    {
        path: "kyc-details/:id",
        component: KycPdfComponent,
        data: {
            title: "Kyc Details",
            urls: [
                {
                    title: 'Kyc Details',
                },
                {
                    title: 'Kyc Details'
                }
            ]
        }
    },
];
let KycRoutingModule = class KycRoutingModule {
};
KycRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], KycRoutingModule);
export { KycRoutingModule };
//# sourceMappingURL=kyc-routing.module.js.map