import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule, DatePipe } from '@angular/common';
import { SharedModule } from '../shared/shared.module';
import { KycRoutingModule } from './kyc-routing.module';
import { KycComponent } from './kyc/kyc.component';
import { DemoMaterialModule } from '../demo-material-module';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { KycPdfComponent } from './kyc-pdf/kyc-pdf.component';
let KycModule = class KycModule {
};
KycModule = __decorate([
    NgModule({
        declarations: [KycComponent, KycPdfComponent],
        imports: [
            CommonModule,
            KycRoutingModule,
            SharedModule,
            DemoMaterialModule,
            ReactiveFormsModule,
            FormsModule
        ],
        providers: [DatePipe]
    })
], KycModule);
export { KycModule };
//# sourceMappingURL=kyc.module.js.map