import { __decorate } from "tslib";
import { Component } from '@angular/core';
let CnpSettingNewComponent = class CnpSettingNewComponent {
    constructor(data, fb) {
        this.data = data;
        this.fb = fb;
        this.submitted = false;
        this.errMessage = "";
    }
    ngOnInit() {
        this.cspForm = this.fb.group({
            csp_id: ['']
        });
        this.data.getCspId().subscribe((res) => {
            this.cspId = res.data;
            this.csp_id = this.cspId[0].csp_id;
            console.log("dataaa", this.csp_id);
        });
    }
    reset() {
        this.csp_id = '';
    }
    onCsp() {
        this.submitted = true;
        if (this.csp_id.invalid) {
            return false;
        }
        else {
            this.data.onAddCspId({ csp_id: this.csp_id }).subscribe(response => {
                console.log("insert data", response);
                if (response.status == 201) {
                    this.responseMessage = response.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.errMessage = response.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
    }
};
CnpSettingNewComponent = __decorate([
    Component({
        selector: 'app-cnp-setting-new',
        templateUrl: './cnp-setting-new.component.html',
        styleUrls: ['./cnp-setting-new.component.css']
    })
], CnpSettingNewComponent);
export { CnpSettingNewComponent };
//# sourceMappingURL=cnp-setting-new.component.js.map