import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { UserprofileComponent } from './userprofile/userprofile.component';
import { ChangepasswordComponent } from './changepassword/changepassword.component';
import { NotificationComponent } from './notification/notification.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: UserprofileComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'user-profile',
                component: UserprofileComponent,
                data: {
                    title: 'Profile',
                    urls: [
                        {
                            title: 'Profile',
                            //   url: '/profile/user-profile'
                        },
                        {
                            title: 'Profile User Profile '
                        }
                    ]
                }
            },
            {
                path: 'change-password',
                component: ChangepasswordComponent,
                data: {
                    title: 'Profile',
                    urls: [
                        {
                            title: 'Profile',
                            // url: '/profile/change-password'
                        },
                        {
                            title: 'Profile Change Password '
                        }
                    ]
                }
            },
            {
                path: 'notification',
                component: NotificationComponent,
                data: {
                    title: 'Profile',
                    urls: [
                        {
                            title: 'Profile',
                            //   url: '/profile/notification'
                        },
                        {
                            title: 'Profile Notification '
                        }
                    ]
                }
            },
        ]
    }
];
let ProfileRoutingModule = class ProfileRoutingModule {
};
ProfileRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], ProfileRoutingModule);
export { ProfileRoutingModule };
//# sourceMappingURL=profile-routing.module.js.map