import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { AppService } from '../shared/service/AppService.class';
import { LoaderEnabled } from '../shared/loader/loader.service';
let ProfileService = class ProfileService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "user";
    }
    getUsers(data) {
        this.appmod = "user";
        let tmp = this.getService(data);
        this.appmod = "usermanagement";
        return tmp;
    }
    SaveData(data, image) {
        let postData;
        postData.append("data", data);
        postData.append("image", image);
        this.appmod = "user";
        let result = super.saveService(postData);
        this.appmod = "usermanagement";
        return result;
    }
};
__decorate([
    LoaderEnabled()
], ProfileService.prototype, "getUsers", null);
ProfileService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ProfileService);
export { ProfileService };
//# sourceMappingURL=profile.service.js.map