import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { ProgrammablevoiceComponent } from './programmablevoice/programmablevoice.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: ProgrammablevoiceComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'programmble-voice',
                component: ProgrammablevoiceComponent,
                data: {
                    title: 'Programmable Voice',
                    urls: [
                        {
                            title: 'Programmable ',
                            //   url: '/programmble/programmble-voice'
                        },
                        {
                            title: 'Programmable Voice'
                        }
                    ]
                }
            },
        ]
    }
];
let ProgrammableRoutingModule = class ProgrammableRoutingModule {
};
ProgrammableRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], ProgrammableRoutingModule);
export { ProgrammableRoutingModule };
//# sourceMappingURL=programmable-routing.module.js.map