import { __decorate } from "tslib";
import { Component, Input, ViewChild } from '@angular/core';
import * as fromInbound from '../../inbound/inbound.reducer';
import * as inboundAction from '../../inbound/inbound.action';
import { BalanceComponent } from 'src/app/usermanagement/profile/balance/balance.component';
import { ImportantNoticeComponent } from '../important-notice/important-notice.component';
import { SystemNotificationComponent } from 'src/app/notification/system-notification/system-notification.component';
// import * as io from 'socket.io-client';
// import { environment } from 'src/environments/environment.prod';
let HeaderNavigationComponent = class HeaderNavigationComponent {
    //   ShowDiv(divVal: string) {
    //       this.currDiv = divVal;
    //     }
    constructor(inboundService, billingService, authService, data, router, them, dialog, store, theme, userSerive, notifydata) {
        // this.socket = io(environment.SOCKETIOURL);
        this.inboundService = inboundService;
        this.billingService = billingService;
        this.authService = authService;
        this.data = data;
        this.router = router;
        this.them = them;
        this.dialog = dialog;
        this.store = store;
        this.theme = theme;
        this.userSerive = userSerive;
        this.notifydata = notifydata;
        this.submitted = false;
        this.isAdmin = false;
        this.isCustomer = false;
        this.isSubCustomer = false;
        this.responseMessage = "";
        this.errMessage = "";
        this.tabStatus = 'justified';
        this.isCollapsed = false;
        this.showSettings = false;
        this.showMobileMenu = false;
        this.isSignUpLogin = false;
        this.disabled = false;
        this.isMyRates = false;
        this.atttheme = "black";
        this.header = "#1269DB";
        this.isalert = false;
        this.emailListData = [];
        this.notificationList = [];
        this.mergedNotificationList = [];
        this.navigate = [];
        this.inboundService.getCart().subscribe(res => {
            let cartItems = [];
            res.data.forEach(element => {
                cartItems.push({ did: element.did });
            });
            this.store.dispatch(new inboundAction.Set(cartItems));
        });
        let session$ = sessionStorage.getItem("isLoggedIn");
        let session = JSON.parse(session$);
        this.sessionType = session.type;
        this.newUserStatus = session.newUser_status;
        if (session.newUser_status == 0) {
            if (session.isEmailVerify == "true" && session.isMobileVerify == "true" && session.isAddress == "true" && session.isPlan == "true") {
                this.disabled = true;
            }
            else {
                this.disabled = false;
            }
        }
        if (session.newUser_status == 1) {
            if (session.isEmailVerify == "true" && session.isMobileVerify == "true" && session.isAddress == "true" && session.isPlan == "true" && session.isCard == "true") {
                this.disabled = true;
            }
            else {
                this.disabled = false;
            }
        }
        if (session.isPlan == "true") {
            this.isMyRates = true;
        }
        else {
            this.isMyRates = false;
        }
        if (session$) {
            this.isSignUpLogin = true;
        }
        this.subscriptionName = this.userSerive.getUpdate().subscribe(message => {
            if (message.text) {
                this.ngOnInit();
            }
        });
    }
    ngOnInit() {
        // this.socket.on('notification', data => {
        //   let authKey=data.data.auth;
        //   console.log("data=======",data);
        //   if(authKey.includes(sessionStorage.getItem('authkey'))){
        //     this.NotificationCountForCustomer();
        //     this.EmailNotificationCount();
        //   } 
        // });
        this.alrt = "2";
        this.counter$ = this.store.select(fromInbound.getCartItems);
        this.data.getUsers("detail").subscribe(res => {
            if (res.data.length > 0) {
                this.userlist = res.data[0];
                this.username = this.userlist[0].user_name;
                this.san = this.userlist[0].san;
                this.email = this.userlist[0].email;
                this.profile_pic = this.userlist[0].profile_pic;
                if (this.profile_pic == undefined) {
                    this.profile_pic = './assets/img/profile.jpg';
                }
            }
        }, error => {
            console.log(error.message);
        });
        this.NotificationCountForCustomer();
        /*Service for kyc response*/
        this.userSerive.getKycHeader().subscribe(res => {
            if (res.status == 200) {
                this.kycHeader = res.data;
                this.kycRes = res.data[0].kyc_verify_status;
                if (this.kycRes == 0) {
                    this.kycRes = "Unverified";
                }
                if (this.kycRes == 1) {
                    this.kycRes = "Verified";
                }
                if (this.kycRes == 2) {
                    this.kycRes = "Verification Pending";
                }
            }
            //   else {
            //     this.errMessage = res.message;
            //     setTimeout(() => {
            //       this.errMessage = "";
            //     }, 5000);
            //   }
            // }, err => {
            //   this.errMessage = err.message;
            //   setTimeout(() => {
            //     this.errMessage = "";
            //   }, 5000);
        });
        this.billingService.getBillingAddress().subscribe(res => {
            if (res.status == 200) {
                this.billingAddress = res.data;
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
        this.billingService.getBalance()
            .subscribe(response => {
            if (response.status = 200) {
                if (response.data.length > 0) {
                    this.balance = response.data[0].balance;
                    this.balanceData = response.data[0];
                    if (!this.balance) {
                        this.balance = 0;
                    }
                    // Low Balance Alert Grayout
                    if (this.balance < this.balanceData.min_balance) {
                        /*  this.isalert=true;
                         this.alrt = "1"
                         setTimeout(() => {
                           this.errrrMessage = "Your current balance is low!";
                         }); */
                    }
                }
                else {
                    this.balance = 0;
                }
            }
            else {
                this.errMessage = response.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
        this.EmailNotificationCount();
        this.notifydata.email_notificationCount$.subscribe(notify => {
            this.Emailcount = notify.count;
            this.navigate = notify.data;
        });
        this.notifydata.notificationCount$.subscribe(notification => {
            this.notificationCount = notification.count;
            this.notificationList = notification.data;
        });
        /*  this.userManagement.getBalance().subscribe(response => {
           if (response.status == 200) {
               this.min_balance = response.data[0].min_balance;
               this.current_balance = response.data[0].balance
             if (this.current_balance < this.min_balance) {
               setTimeout(() => {
                 this.errrrMessage = "Your current balance is low!";
               });
             }
           }
           
         }) */
    }
    NotificationCountForCustomer() {
        this.notifydata.NotificationCountForCustomer().subscribe((res) => {
            if (res.status == 200) {
                this.notificationList = res.data;
                this.notificationCount = this.notificationList.length;
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    navigateToSystemNotification(keys) {
        this.notifydata.UpdateViewNotificationStatus(keys).subscribe((res) => {
            if (res.status == 200) {
                this.NotificationCountForCustomer();
                this.router.navigate(['/system-notification'], {
                    queryParams: {
                        key: keys
                    }
                });
                this.SystemNotification.notificationScrollIntoView();
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    makePayment() {
        const dialogRef = this.dialog.open(BalanceComponent, {
            data: { balance: this.balanceData, userProfile: this.userlist, address: this.billingAddress },
            disableClose: true
        });
        dialogRef.componentInstance.submitClicked.subscribe(result => {
            this.errMessage = result;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
        dialogRef.afterClosed().subscribe(result => {
            if (result.reload) {
                this.disabled = false;
                window.location.reload();
                this.responseMessage = result.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = result.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        });
    }
    UpdateCount(key, to, view_status) {
        let payLoad = JSON.stringify({
            key: key,
            email: to,
            view: view_status
        });
        this.notifydata.update_status(payLoad).subscribe((res) => {
            this.notifydata.NotificationCount().subscribe((res1) => {
                this.notifydata.updateCount(res1.data.length, res1.data);
            });
            if (res.status == 201) {
                const url = `/notification/${key}/${to}/${view_status}/${view_status}`;
                const url1 = `/notification/${key}/${to}/${view_status}`;
                const currentUrl = this.router.url;
                const slashesCount = currentUrl.split('/').length - 1;
                if (slashesCount === 4) {
                    this.router.navigateByUrl(url);
                }
                else {
                    this.router.navigateByUrl(url1);
                }
                this.responseMessage = '';
                setTimeout(() => {
                    this.responseMessage = '';
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    EmailNotificationCount() {
        this.notifydata.getemail_notification().subscribe((res) => {
            if (res.status == 201) {
                this.Customernotify = res.data;
                let UnreadEmail = this.Customernotify.filter(notification => notification.view_status === 0);
                this.navigate = this.Customernotify;
                this.Emailcount = UnreadEmail.length;
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = '';
                }, 5000);
            }
        });
    }
    importantNotice() {
        const dialogRef = this.dialog.open(ImportantNoticeComponent, {
            data: {},
            disableClose: true
        });
    }
    onClickAlr() {
        this.alrt = "2";
    }
    onLogout() {
        this.authService.logout();
    }
    ngOnDestroy() {
        this.leftsetting = false;
    }
    truncatenotification(subject, maxLength) {
        return subject.length > maxLength ? subject.substring(0, maxLength) + '..' : subject;
    }
};
__decorate([
    ViewChild(SystemNotificationComponent)
], HeaderNavigationComponent.prototype, "SystemNotification", void 0);
__decorate([
    Input()
], HeaderNavigationComponent.prototype, "leftsetting", void 0);
__decorate([
    Input()
], HeaderNavigationComponent.prototype, "atttheme", void 0);
__decorate([
    Input()
], HeaderNavigationComponent.prototype, "header", void 0);
HeaderNavigationComponent = __decorate([
    Component({
        selector: 'app-header-navigation',
        templateUrl: './header-navigation.component.html',
        styleUrls: ['./header-navigation.component.css']
    })
], HeaderNavigationComponent);
export { HeaderNavigationComponent };
//# sourceMappingURL=header-navigation.component.js.map