import { __decorate } from "tslib";
import { Injectable } from "@angular/core";
import { AppService } from "../service/AppService.class";
import { LoaderEnabled } from "../loader/loader.service";
let MenuService = class MenuService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
        this.appmod = "getcdr";
    }
    // public getMenu():Observable<any>{
    //   return this.http.get('./assets/menu.json');
    // }
    getAdminMenu() {
        return this.http.get("./assets/adminmenu.json");
    }
    getCustomerMenu() {
        return this.http.get('./assets/customermenu.json');
    }
    getCustomersideMenu() {
        return this.http.get('./assets/customersidemenu.json');
    }
    getCustomersideMenuForKyc() {
        return this.http.get('./assets/customermenuforkyc.json');
    }
    getSubCustomer() {
        return this.http.get('./assets/sub-customer.json');
    }
    getSupplierMenu() {
        return this.http.get('./assets/suppliermenu.json');
    }
    getSignupMenu() {
        return this.http.get('./assets/signupmenu.json');
    }
    getCustomersideMenuForVerifykyc() {
        return this.http.get('./assets/customermenuforVerifykyc.json');
    }
};
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getAdminMenu", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getCustomerMenu", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getCustomersideMenu", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getCustomersideMenuForKyc", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getSubCustomer", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getSupplierMenu", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getSignupMenu", null);
__decorate([
    LoaderEnabled()
], MenuService.prototype, "getCustomersideMenuForVerifykyc", null);
MenuService = __decorate([
    Injectable()
], MenuService);
export { MenuService };
//# sourceMappingURL=menu.service.js.map