var StatusComponent_1;
import { __decorate } from "tslib";
import { Component, Input, Output, EventEmitter, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR, NG_VALIDATORS } from '@angular/forms';
let StatusComponent = StatusComponent_1 = class StatusComponent {
    constructor() {
        this.propagateChange = () => { };
        this.validateFn = () => { };
        this._curstatus = 0;
        this.active = new EventEmitter();
        this.inactive = new EventEmitter();
        this.state = true;
        this.state2 = false;
    }
    get curstatus() {
        return this._curstatus;
    }
    set curstatus(val) {
        this._curstatus = val;
        this.propagateChange(val);
    }
    ngOnChanges(inputs) {
        this.propagateChange(this.curstatus);
    }
    writeValue(value) {
        if (value) {
            this.curstatus = value;
        }
    }
    registerOnChange(fn) {
        this.propagateChange = fn;
    }
    registerOnTouched() { }
    ngOnInit() {
        if (this.toggle) {
            if (this._curstatus == 1)
                this.optstatus = true;
            else if (this._curstatus == 0)
                this.optstatus = false;
            else {
                this.state = false;
                this.state2 = true;
            }
        }
    }
    OnChange(events) {
        console.log(events.target.checked);
        console.log(this._curstatus);
        if (events.target.checked === true) {
            console.log("Currently checked");
            this.active.emit(true);
            this.optstatus = true;
            this._curstatus = 1;
        }
        else {
            console.log("Currently unchecked");
            this.inactive.emit(true);
            //this.active.emit(false);
            this.optstatus = false;
            this._curstatus = 0;
            //this.checked=false;
        }
        console.log(this._curstatus);
    }
};
__decorate([
    Input()
], StatusComponent.prototype, "textlabel", void 0);
__decorate([
    Input('curstatus')
], StatusComponent.prototype, "_curstatus", void 0);
__decorate([
    Input()
], StatusComponent.prototype, "toggleclass", void 0);
__decorate([
    Input()
], StatusComponent.prototype, "toggle", void 0);
__decorate([
    Output()
], StatusComponent.prototype, "active", void 0);
__decorate([
    Output()
], StatusComponent.prototype, "inactive", void 0);
StatusComponent = StatusComponent_1 = __decorate([
    Component({
        selector: 'app-status',
        templateUrl: './status.component.html',
        styleUrls: ['./status.component.css'],
        providers: [
            { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(() => StatusComponent_1), multi: true },
            { provide: NG_VALIDATORS, useExisting: forwardRef(() => StatusComponent_1), multi: true }
        ]
    })
], StatusComponent);
export { StatusComponent };
//# sourceMappingURL=status.component.js.map