import { __decorate } from "tslib";
import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { HttpClientModule } from '@angular/common/http';
import { AngularEditorModule } from '@kolkov/angular-editor';
import { SignuptemplateRoutingModule } from './signuptemplate-routing.module';
import { SmstemplateComponent } from './smstemplate/smstemplate.component';
import { EmailtemplateComponent } from './emailtemplate/emailtemplate.component';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { NgxPaginationModule } from 'ngx-pagination';
import { Ng2SearchPipeModule } from 'ng2-search-filter';
import { FormsModule } from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import { SharedModule } from '../shared/shared.module';
import { MatTooltipModule } from '@angular/material/tooltip';
import { EmailtemplatedetailsComponent } from './emailtemplatedetails/emailtemplatedetails.component';
import { SmstemplatedetailsComponent } from './smstemplatedetails/smstemplatedetails.component';
import { FactorauthenticationComponent } from './factorauthentication/factorauthentication.component';
import { FactorauthenticationdetailsComponent } from './factorauthenticationdetails/factorauthenticationdetails.component';
import { MatMenuModule } from '@angular/material/menu';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MmsComponent } from './mms/mms.component';
import { MmstemplateComponent } from './mmstemplate/mmstemplate.component';
import { OrderPipe } from './orderPipe.pipe';
let SignuptemplateModule = class SignuptemplateModule {
};
SignuptemplateModule = __decorate([
    NgModule({
        declarations: [SmstemplateComponent, EmailtemplateComponent, EmailtemplatedetailsComponent, SmstemplatedetailsComponent, FactorauthenticationComponent, FactorauthenticationdetailsComponent, MmsComponent, MmstemplateComponent, OrderPipe],
        imports: [
            CommonModule,
            SignuptemplateRoutingModule,
            HttpClientModule,
            NgxPaginationModule,
            Ng2SearchPipeModule,
            NgbModule,
            FormsModule,
            ReactiveFormsModule,
            AngularEditorModule,
            SharedModule,
            MatMenuModule,
            MatSlideToggleModule,
            MatTooltipModule
        ],
        schemas: [CUSTOM_ELEMENTS_SCHEMA]
    })
], SignuptemplateModule);
export { SignuptemplateModule };
//# sourceMappingURL=signuptemplate.module.js.map