import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let SmstemplatedetailsComponent = class SmstemplatedetailsComponent extends AppComponentClass {
    constructor(data, router, fb, route) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.route = route;
        this.page = 1;
        this.count = 0;
        this.tableSize = 25;
        this.tableSizes = [25, 50, 100];
        this.searchText = { count: 0 };
        this.errMessage = "";
    }
    ngOnInit() {
        this.data.getSmsTemplates().subscribe(res => {
            if (res.status == 200) {
                this.listdata = res.data;
                $.getScript('./assets/table.js');
            }
            else {
                this.errMessage = "";
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
    onToggle(event, id) {
        this.data.updateStatusSMS(event.checked, id).subscribe(res => {
            console.log(res);
            if (res.status == 201) {
                this.ngOnInit();
                this.responseMessage = res.message;
                setTimeout(() => {
                    this.responseMessage = "";
                }, 5000);
            }
            else {
                this.errMessage = res.message;
                setTimeout(() => {
                    this.errMessage = "";
                }, 5000);
            }
        }, err => {
            this.errMessage = err.message;
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        });
    }
};
SmstemplatedetailsComponent = __decorate([
    Component({
        selector: 'app-smstemplatedetails',
        templateUrl: './smstemplatedetails.component.html',
        styleUrls: ['./smstemplatedetails.component.css']
    })
], SmstemplatedetailsComponent);
export { SmstemplatedetailsComponent };
//# sourceMappingURL=smstemplatedetails.component.js.map