import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { outboundsmsForm } from '../sms.class';
let OutboundsmsComponent = class OutboundsmsComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.submitted = false;
    }
    ngOnInit() {
        this.data.get_smsconf().subscribe((result) => {
            this.label = result[1];
            console.log(result);
        });
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new outboundsmsForm(res);
                this.keyfield = res.id;
                this.outboundsmsForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new outboundsmsForm(null);
                this.keyfield = -1;
                this.outboundsmsForm = this.cdata.makeform(this.fb);
            }
        });
    }
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.outboundsmsForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.outboundsmsForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
};
OutboundsmsComponent = __decorate([
    Component({
        selector: 'app-outboundsms',
        templateUrl: './outboundsms.component.html',
        styleUrls: ['./outboundsms.component.css']
    })
], OutboundsmsComponent);
export { OutboundsmsComponent };
//# sourceMappingURL=outboundsms.component.js.map