import { __decorate } from "tslib";
import { Pipe } from "@angular/core";
let TimeFormatPipe = class TimeFormatPipe {
    transform(value) {
        const hours = Math.floor(value / 3600);
        const minutes = Math.floor((value % 3600) / 60);
        return ('00' + hours).slice(-2) + ':' + ('00' + minutes).slice(-2) + ':' + ('00' + Math.floor(value - minutes * 60)).slice(-2);
    }
};
TimeFormatPipe = __decorate([
    Pipe({
        name: 'timeFormat'
    })
], TimeFormatPipe);
export { TimeFormatPipe };
//# sourceMappingURL=time-format.pipe.js.map