import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { didForm } from '../supplier.class';
let DiduploadComponent = class DiduploadComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
    }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                console.log("Update data " + JSON.stringify(res));
                this.cdata = new didForm(res);
                this.keyfield = res.id;
                this.didForm = this.cdata.makeform(this.fb);
            }
            else {
                console.log("adding data " + JSON.stringify(res));
                this.cdata = new didForm(null);
                this.keyfield = -1;
                this.didForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.getdidupload().subscribe((result) => {
            this.modelform = result;
            console.log(result);
        });
    }
    // @to save/update form data
    onSubmit() {
        console.log("event task save");
        this.submitted = true;
        if (this.didForm.invalid) {
            return false;
        }
        else {
            console.log("submit data::", this.cdata);
            if (this.cdata.saveForm(this.didForm)) {
                console.log("Submitted data ::\n" + JSON.stringify(this.cdata));
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        console.log("Response data::\n", res);
                        this.ngOnInit();
                    });
                }
            }
        }
    }
};
DiduploadComponent = __decorate([
    Component({
        selector: 'app-didupload',
        templateUrl: './didupload.component.html',
        styleUrls: ['./didupload.component.css']
    })
], DiduploadComponent);
export { DiduploadComponent };
//# sourceMappingURL=didupload.component.js.map