import { Validators } from "@angular/forms";
export class supplierForm {
    constructor(data) {
        if (data == null) {
            this.first_name = "";
            this.last_name = "";
            this.phone = "";
            this.user_name = "";
            this.password = "";
        }
        else {
            this.first_name = data.first_name;
            this.last_name = data.last_name;
            this.phone = data.phone;
            this.user_name = data.user_name;
            this.password = data.password;
        }
    }
    makeform(fb) {
        return fb.group({
            first_name: [this.first_name, Validators.required],
            last_name: [this.last_name, Validators.required],
            phone: [this.phone, Validators.pattern(new RegExp("[0-9 ]{12}"))],
            user_name: [this.user_name, Validators.required],
            password: [this.password, Validators],
        });
    }
    saveForm(fg) {
        if (fg.valid) {
            this.password = fg.get("password").value;
            this.last_name = fg.get("last_name").value;
            this.phone = fg.get("phone").value;
            this.user_name = fg.get("user_name").value;
            this.password = fg.get("password").value;
            return true;
        }
        else {
            return false;
        }
    }
}
export class didForm {
    constructor(data) {
        if (data == null) {
            this.did = "";
        }
        else {
            this.did = data.did;
        }
    }
    makeform(fb) {
        return fb.group({
            did: [this.did, [Validators.required]],
        });
    }
    saveForm(fg) {
        if (fg.valid) {
            this.did = fg.get("did").value;
            return true;
        }
        else {
            return false;
        }
    }
}
export class intgratedsolutionsForm {
    constructor(data) {
        if (data == null) {
            this.api_key = "";
            this.api_secret = "";
        }
        else {
            this.api_key = data.api_key;
            this.api_secret = data.api_secret;
        }
    }
    makeform(fb) {
        return fb.group({
            api_key: [this.api_key, [Validators.required]],
            api_secret: [this.api_secret, [Validators.required]],
        });
    }
    saveForm(fg) {
        if (fg.valid) {
            this.api_key = fg.get("api_key").value;
            this.api_secret = fg.get("api_secret").value;
            return true;
        }
        else {
            return false;
        }
    }
}
//# sourceMappingURL=supplier.class.js.map