import { __decorate } from "tslib";
import { Injectable } from '@angular/core';
import { HttpHeaders } from '@angular/common/http';
import { AppService } from '../shared/service/AppService.class';
import { environment } from 'src/environments/environment';
let SupplierService = class SupplierService extends AppService {
    constructor(http) {
        super(http);
        this.http = http;
    }
    saveData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    updateData(data) {
        let tmp = this.appmod;
        this.appmod = 'custom/saveheadermapping';
        let result = super.saveService(data);
        this.appmod = tmp;
        return result;
    }
    getsuppiler() {
        return this.http.get('./assets/supplier.json');
    }
    getdidupload() {
        return this.http.get('./assets/uploaddid.json');
    }
    getintegrated() {
        return this.http.get('./assets/integrated.json');
    }
    getrecord() {
        return this.http.get('./assets/didreport.json');
    }
    saveFile(fileName, type) {
        const endpoint = environment.SERVER + 'uploads/document_upload';
        let formData = new FormData();
        formData.append("fileName", fileName);
        formData.append("type", type);
        console.log(formData);
        let httpHeaders = new HttpHeaders({});
        return this.http.post(endpoint, formData, { headers: httpHeaders });
    }
    download(url) {
        return this.http.get(url, {
            responseType: 'blob'
        });
    }
};
SupplierService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], SupplierService);
export { SupplierService };
//# sourceMappingURL=supplier.service.js.map