import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { SuppliermanagementRoutingModule } from './suppliermanagement-routing.module';
import { SupplierComponent } from './supplier/supplier.component';
import { Ng2SearchPipeModule } from 'ng2-search-filter';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { FormsModule } from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import { SupplierService } from './supplier.service';
import { NgxPaginationModule } from 'ngx-pagination';
import { ItegratedsolutionsComponent } from './itegratedsolutions/itegratedsolutions.component';
import { UsermanagementModule } from '../usermanagement/usermanagement.module';
let SuppliermanagementModule = class SuppliermanagementModule {
};
SuppliermanagementModule = __decorate([
    NgModule({
        declarations: [SupplierComponent, ItegratedsolutionsComponent],
        imports: [
            CommonModule,
            SuppliermanagementRoutingModule,
            ReactiveFormsModule,
            FormsModule,
            NgbModule,
            Ng2SearchPipeModule,
            NgxPaginationModule,
            UsermanagementModule
        ],
        providers: [SupplierService]
    })
], SuppliermanagementModule);
export { SuppliermanagementModule };
//# sourceMappingURL=suppliermanagement.module.js.map