import { __decorate } from "tslib";
import { Component, ViewChild } from '@angular/core';
let LerginfoComponent = class LerginfoComponent {
    constructor(formBuilder, tariffSevice) {
        this.formBuilder = formBuilder;
        this.tariffSevice = tariffSevice;
        this.show = false;
        this.buttonName = "Add";
        this.page = 1;
        this.count = 0;
        this.tableSize = 50;
        this.tableSizes = [50, 100, 200];
        this.responseMessage = "";
        this.errMessage = "";
    }
    ngOnInit() {
        this.tariffSevice.get_lerginfo().subscribe((result) => {
            this.header = result[0].headers_details;
        });
        this.getLead();
    }
    getLead() {
        this.tariffSevice.getleadinfo().subscribe((result) => {
            $('#basic-datatables').DataTable().clear();
            $('#basic-datatables').DataTable().destroy();
            this.listdata = result.data;
            $.getScript('./assets/table.js');
        });
    }
    resetLerg() {
        this.InputVar.nativeElement.value = "";
    }
    pickedFile(event) {
        const file = event.target.files[0];
        this.lerg_file = file;
        const reader = new FileReader();
        reader.readAsDataURL(file);
    }
    uploadLerg() {
        if (this.lerg_file) {
            this.tariffSevice.uploadLergFile(this.lerg_file).subscribe(res => {
                if (res.status == 201) {
                    // $("#exampleModal").hide();
                    // $(".modal-backdrop").remove();
                    this.getLead();
                    document.getElementById("closeLergeModal").click();
                    this.responseMessage = res.message;
                    setTimeout(() => {
                        this.responseMessage = "";
                    }, 5000);
                }
                else {
                    this.errMessage = res.message;
                    setTimeout(() => {
                        this.errMessage = "";
                    }, 5000);
                }
            });
        }
        else {
            this.errMessage = "File is required!";
            setTimeout(() => {
                this.errMessage = "";
            }, 5000);
        }
    }
    toggle() {
        this.show = !this.show;
        if (this.show)
            this.buttonName = "Close";
        else
            this.buttonName = "Add";
    }
};
__decorate([
    ViewChild("takeInput", { static: false })
], LerginfoComponent.prototype, "InputVar", void 0);
LerginfoComponent = __decorate([
    Component({
        selector: 'app-lerginfo',
        templateUrl: './lerginfo.component.html',
        styleUrls: ['./lerginfo.component.css']
    })
], LerginfoComponent);
export { LerginfoComponent };
//# sourceMappingURL=lerginfo.component.js.map