import { __decorate } from "tslib";
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { TierComponent } from './tier/tier.component';
const routes = [
    {
        path: '',
        children: [
            {
                path: '',
                component: TierComponent,
                data: {
                    title: 'Dashboard',
                    urls: [
                        {
                            title: 'Dashboard',
                            url: '/dashboards/dashboard'
                        },
                        {
                            title: 'Dashboard'
                        }
                    ]
                }
            },
            {
                path: 'tier',
                component: TierComponent,
                data: {
                    title: 'Tier Management',
                    urls: [
                        {
                            title: 'Tier Management',
                            //   url: 'tier'
                        },
                        {
                            title: 'Tier'
                        }
                    ]
                }
            },
        ]
    }
];
let TiermanagementRoutingModule = class TiermanagementRoutingModule {
};
TiermanagementRoutingModule = __decorate([
    NgModule({
        imports: [RouterModule.forChild(routes)],
        exports: [RouterModule]
    })
], TiermanagementRoutingModule);
export { TiermanagementRoutingModule };
//# sourceMappingURL=tiermanagement-routing.module.js.map