import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { didForm } from '../user.class';
let DiduploadComponent = class DiduploadComponent extends AppComponentClass {
    constructor(data, router, fb) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.p = 1;
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
        this.fileToUpload = null;
    }
    ngOnInit() {
        // @subscribing form group
        this.data.solution.subscribe(res => {
            if (res != null) {
                this.cdata = new didForm(res);
                this.keyfield = res.id;
                this.didForm = this.cdata.makeform(this.fb);
            }
            else {
                this.cdata = new didForm(null);
                this.keyfield = -1;
                this.didForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.getdidupload().subscribe((result) => {
            this.modelform = result;
        });
    }
    // @to save/update form data
    onSubmit() {
        this.submitted = true;
        if (this.didForm.invalid) {
            return false;
        }
        else {
            if (this.cdata.saveForm(this.didForm)) {
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    handleFileInput(files) {
        let sessionid = 32;
        let filetype = "agent guide";
        files.item(0)["sessionid"] = sessionid;
        files.item(0)["filetyepe"] = filetype;
        this.fileToUpload = files.item(0);
        this.data.postFile(this.fileToUpload, sessionid, filetype).subscribe(res => {
            this.file = res.filename;
        }, error => {
            console.log(error);
        });
    }
};
DiduploadComponent = __decorate([
    Component({
        selector: 'app-didupload',
        templateUrl: './didupload.component.html',
        styleUrls: ['./didupload.component.css']
    })
], DiduploadComponent);
export { DiduploadComponent };
//# sourceMappingURL=didupload.component.js.map