import { __decorate } from "tslib";
import { Component } from '@angular/core';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
import { intgratedsolutionsForm } from '../user.class';
import { Base64 } from 'js-base64';
import { AddParamsComponent } from '../usermanagement/addparams/addparams.component';
let ItegratedsolutionsComponent = class ItegratedsolutionsComponent extends AppComponentClass {
    constructor(data, router, fb, dialog) {
        super(data, router, fb);
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.dialog = dialog;
        this.p = 1;
        this.show = false;
        this.buttonName = "Add";
        this.submitted = false;
        this.loadfrm = false;
        this.gToken = "";
        this.enable = false;
    }
    //console.log(localStorage.getItem('type')) ;
    ngOnInit() {
        this.data.solution.subscribe(res => {
            if (res != null) {
                this.cdata = new intgratedsolutionsForm(res);
                this.keyfield = res.id;
                this.intgratedsolutionsForm = this.cdata.makeform(this.fb);
            }
            else {
                this.cdata = new intgratedsolutionsForm(null);
                this.keyfield = -1;
                this.intgratedsolutionsForm = this.cdata.makeform(this.fb);
            }
        });
        this.data.getintegrated().subscribe((result) => {
            this.listdata = result;
        });
        this.data.getintegratedAPI().subscribe(res => {
            this.rowdata = res;
            let frm = {};
            res.forEach(element => {
                element.data.forEach(ele => {
                    frm[ele.formControl] = [];
                });
            });
            this.modelform = this.fb.group(frm);
            this.loadfrm = true;
        });
    }
    getEncodedToken(token) {
        this.gToken = Base64.encode(token);
    }
    // @to save/update form data
    onSubmit() {
        this.userType = sessionStorage.getItem('type');
        this.submitted = true;
        if (this.intgratedsolutionsForm.invalid) {
            return false;
        }
        else {
            if (this.cdata.saveForm(this.intgratedsolutionsForm)) {
                this.cdata['supplierid'] = this.userType;
                this.data.api(this.cdata).subscribe(res => {
                }, error => {
                    console.log(error);
                });
                if (this.keyfield == -1) {
                    this.data.saveData(JSON.stringify(this.cdata)).subscribe(res => {
                        this.ngOnInit();
                    });
                }
                else {
                    this.data.updateData(JSON.stringify(this.cdata)).subscribe(res => {
                        this.ngOnInit();
                    });
                }
            }
        }
    }
    onChange(event) {
        if (event.target.checked) {
            this.enable = true;
        }
        else {
            this.enable = false;
        }
    }
    addSetting(type) {
        let tmp = sessionStorage.getItem("isLoggedIn");
        tmp = JSON.parse(tmp);
        const dialogRef = this.dialog.open(AddParamsComponent, {
            width: '600px', disableClose: true,
            data: { iduser: tmp.iduser, type: type, idaccount: tmp.account, dialogtype: 1, savetype: 1 }
        });
    }
};
ItegratedsolutionsComponent = __decorate([
    Component({
        selector: 'app-itegratedsolutions',
        templateUrl: './itegratedsolutions.component.html',
        styleUrls: ['./itegratedsolutions.component.css']
    })
], ItegratedsolutionsComponent);
export { ItegratedsolutionsComponent };
//# sourceMappingURL=itegratedsolutions.component.js.map