import { __decorate, __param } from "tslib";
import { Component, Inject, Input } from '@angular/core';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import { AppComponentClass } from 'src/app/shared/service/AppComponent.class';
let AddParamsComponent = class AddParamsComponent extends AppComponentClass {
    constructor(dialogRef, ddata, data, router, fb) {
        super(data, router, fb);
        this.dialogRef = dialogRef;
        this.ddata = ddata;
        this.data = data;
        this.router = router;
        this.fb = fb;
        this.curuserid = -1;
        this.show = false;
        this.show1 = false;
        this.savetype = 0;
        this.submitted = false;
    }
    ngOnInit() {
        this.boxtype = this.ddata.type;
    }
    onAddUser() {
        this.submitted = true;
        if (this.addparamsForm.invalid) {
            return false;
        }
        else {
            if (this.savetype == 0) {
                this.data.SaveUserData(this.addparamsForm.value).subscribe(res => {
                    this.dialogRef.close(1);
                });
            }
            if (this.savetype == 1) {
                this.data.SaveAdminData(this.addparamsForm.value).subscribe(res => {
                    this.dialogRef.close(1);
                });
            }
        }
    }
    close() {
        this.dialogRef.close(-1);
    }
};
__decorate([
    Input()
], AddParamsComponent.prototype, "usertype", void 0);
__decorate([
    Input()
], AddParamsComponent.prototype, "curuserid", void 0);
AddParamsComponent = __decorate([
    Component({
        selector: 'app-addparams',
        templateUrl: './addparams.component.html',
        styleUrls: ['./addparams.component.css']
    }),
    __param(1, Inject(MAT_DIALOG_DATA))
], AddParamsComponent);
export { AddParamsComponent };
//# sourceMappingURL=addparams.component.js.map