import { __decorate } from "tslib";
import { Pipe } from '@angular/core';
let UserType = class UserType {
    transform(details) {
        switch (details) {
            case 1:
                return "Admin";
            case 12:
                return "Sub-Admin";
            case 2:
                return "Customer";
            case 22:
                return "Sub-Customer";
            case 3:
                return "Supplier";
            case 32:
                return "Sub-Supplier";
            case 4:
                return "Reseller";
            case 42:
                return "Sub-Reseller";
        }
    }
};
UserType = __decorate([
    Pipe({ name: 'UserType' })
], UserType);
export { UserType };
let ParamTitle = class ParamTitle {
    transform(details) {
        return details.replace(new RegExp('_'), " ").toUpperCase();
    }
};
ParamTitle = __decorate([
    Pipe({ name: 'ParamTitle' })
], ParamTitle);
export { ParamTitle };
//# sourceMappingURL=users.pipe.js.map